/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
 this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}


/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a<<8) | b)

static int make_pair(int i1, int i2)
{
  unsigned u1 = i1;
  unsigned u2 = i2;

  if ((u1 > 0xFFFF) || (u2 > 0xFFFF))
    cf_error( "Can't operate with value out of bounds in pair constructor");

  return (u1 << 16) | u2;
}

struct f_tree *f_generate_rev_wcard(int from, int to, int expr)
{
	struct f_tree *ret = NULL, *last = NULL;

	while (from <= to) {
		ret = f_new_tree(); 
		ret->from.type = ret->to.type = T_PAIR;
		ret->from.val.i = ret->to.val.i = make_pair(from, expr); 
		ret->left = last;

		from++; last = ret;
	}
	return ret;
}

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->stub != 0))
    cf_error( "Backbone area cannot be stub");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "No configured areas in OSPF");
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix

static struct radv_prefix_config *this_radv_prefix;

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;



/* Line 189 of yacc.c  */
#line 314 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     GEQ = 262,
     LEQ = 263,
     NEQ = 264,
     AND = 265,
     OR = 266,
     PO = 267,
     PC = 268,
     NUM = 269,
     ENUM = 270,
     RTRID = 271,
     IPA = 272,
     SYM = 273,
     TEXT = 274,
     PREFIX_DUMMY = 275,
     DEFINE = 276,
     ON = 277,
     OFF = 278,
     YES = 279,
     NO = 280,
     LOG = 281,
     SYSLOG = 282,
     ALL = 283,
     DEBUG = 284,
     TRACE = 285,
     INFO = 286,
     REMOTE = 287,
     WARNING = 288,
     ERROR = 289,
     AUTH = 290,
     FATAL = 291,
     BUG = 292,
     STDERR = 293,
     SOFT = 294,
     TIMEFORMAT = 295,
     ISO = 296,
     SHORT = 297,
     LONG = 298,
     BASE = 299,
     NAME = 300,
     CONFIGURE = 301,
     DOWN = 302,
     KERNEL = 303,
     PERSIST = 304,
     SCAN = 305,
     TIME = 306,
     LEARN = 307,
     DEVICE = 308,
     ROUTES = 309,
     ASYNC = 310,
     TABLE = 311,
     KRT_PREFSRC = 312,
     KRT_REALM = 313,
     ROUTER = 314,
     ID = 315,
     PROTOCOL = 316,
     PREFERENCE = 317,
     DISABLED = 318,
     DIRECT = 319,
     INTERFACE = 320,
     IMPORT = 321,
     EXPORT = 322,
     FILTER = 323,
     NONE = 324,
     STATES = 325,
     FILTERS = 326,
     PASSWORD = 327,
     FROM = 328,
     PASSIVE = 329,
     TO = 330,
     EVENTS = 331,
     PACKETS = 332,
     PROTOCOLS = 333,
     INTERFACES = 334,
     PRIMARY = 335,
     STATS = 336,
     COUNT = 337,
     FOR = 338,
     COMMANDS = 339,
     PREEXPORT = 340,
     GENERATE = 341,
     LISTEN = 342,
     BGP = 343,
     V6ONLY = 344,
     DUAL = 345,
     ADDRESS = 346,
     PORT = 347,
     PASSWORDS = 348,
     DESCRIPTION = 349,
     RELOAD = 350,
     IN = 351,
     OUT = 352,
     MRTDUMP = 353,
     MESSAGES = 354,
     RESTRICT = 355,
     MEMORY = 356,
     IGP_METRIC = 357,
     SHOW = 358,
     STATUS = 359,
     SUMMARY = 360,
     ROUTE = 361,
     SYMBOLS = 362,
     DUMP = 363,
     RESOURCES = 364,
     SOCKETS = 365,
     NEIGHBORS = 366,
     ATTRIBUTES = 367,
     ECHO = 368,
     DISABLE = 369,
     ENABLE = 370,
     RESTART = 371,
     FUNCTION = 372,
     PRINT = 373,
     PRINTN = 374,
     UNSET = 375,
     RETURN = 376,
     ACCEPT = 377,
     REJECT = 378,
     QUITBIRD = 379,
     INT = 380,
     BOOL = 381,
     IP = 382,
     PREFIX = 383,
     PAIR = 384,
     QUAD = 385,
     SET = 386,
     STRING = 387,
     BGPMASK = 388,
     BGPPATH = 389,
     CLIST = 390,
     IF = 391,
     THEN = 392,
     ELSE = 393,
     CASE = 394,
     TRUE = 395,
     FALSE = 396,
     GW = 397,
     NET = 398,
     MASK = 399,
     PROTO = 400,
     SOURCE = 401,
     SCOPE = 402,
     CAST = 403,
     DEST = 404,
     LEN = 405,
     DEFINED = 406,
     ADD = 407,
     DELETE = 408,
     CONTAINS = 409,
     RESET = 410,
     PREPEND = 411,
     FIRST = 412,
     LAST = 413,
     MATCH = 414,
     EMPTY = 415,
     WHERE = 416,
     EVAL = 417,
     LOCAL = 418,
     NEIGHBOR = 419,
     AS = 420,
     HOLD = 421,
     CONNECT = 422,
     RETRY = 423,
     KEEPALIVE = 424,
     MULTIHOP = 425,
     STARTUP = 426,
     VIA = 427,
     NEXT = 428,
     HOP = 429,
     SELF = 430,
     DEFAULT = 431,
     PATH = 432,
     METRIC = 433,
     START = 434,
     DELAY = 435,
     FORGET = 436,
     WAIT = 437,
     AFTER = 438,
     BGP_PATH = 439,
     BGP_LOCAL_PREF = 440,
     BGP_MED = 441,
     BGP_ORIGIN = 442,
     BGP_NEXT_HOP = 443,
     BGP_ATOMIC_AGGR = 444,
     BGP_AGGREGATOR = 445,
     BGP_COMMUNITY = 446,
     RR = 447,
     RS = 448,
     CLIENT = 449,
     CLUSTER = 450,
     AS4 = 451,
     ADVERTISE = 452,
     IPV4 = 453,
     CAPABILITIES = 454,
     LIMIT = 455,
     PREFER = 456,
     OLDER = 457,
     MISSING = 458,
     LLADDR = 459,
     DROP = 460,
     IGNORE = 461,
     REFRESH = 462,
     INTERPRET = 463,
     COMMUNITIES = 464,
     BGP_ORIGINATOR_ID = 465,
     BGP_CLUSTER_LIST = 466,
     IGP = 467,
     GATEWAY = 468,
     RECURSIVE = 469,
     MED = 470,
     OSPF = 471,
     AREA = 472,
     OSPF_METRIC1 = 473,
     OSPF_METRIC2 = 474,
     OSPF_TAG = 475,
     OSPF_ROUTER_ID = 476,
     RFC1583COMPAT = 477,
     STUB = 478,
     TICK = 479,
     COST = 480,
     RETRANSMIT = 481,
     HELLO = 482,
     TRANSMIT = 483,
     PRIORITY = 484,
     DEAD = 485,
     TYPE = 486,
     BROADCAST = 487,
     BCAST = 488,
     NONBROADCAST = 489,
     NBMA = 490,
     POINTOPOINT = 491,
     PTP = 492,
     POINTOMULTIPOINT = 493,
     PTMP = 494,
     SIMPLE = 495,
     AUTHENTICATION = 496,
     STRICT = 497,
     CRYPTOGRAPHIC = 498,
     ELIGIBLE = 499,
     POLL = 500,
     NETWORKS = 501,
     HIDDEN = 502,
     VIRTUAL = 503,
     CHECK = 504,
     LINK = 505,
     RX = 506,
     BUFFER = 507,
     LARGE = 508,
     NORMAL = 509,
     STUBNET = 510,
     LSADB = 511,
     ECMP = 512,
     WEIGHT = 513,
     TOPOLOGY = 514,
     STATE = 515,
     PIPE = 516,
     PEER = 517,
     MODE = 518,
     OPAQUE = 519,
     TRANSPARENT = 520,
     RADV = 521,
     MIN = 522,
     MAX = 523,
     RA = 524,
     INTERVAL = 525,
     MANAGED = 526,
     OTHER = 527,
     CONFIG = 528,
     MTU = 529,
     REACHABLE = 530,
     RETRANS = 531,
     TIMER = 532,
     CURRENT = 533,
     VALID = 534,
     PREFERRED = 535,
     LIFETIME = 536,
     SKIP = 537,
     ONLINK = 538,
     AUTONOMOUS = 539,
     RIP = 540,
     INFINITY = 541,
     PERIOD = 542,
     GARBAGE = 543,
     TIMEOUT = 544,
     MULTICAST = 545,
     QUIET = 546,
     NOLISTEN = 547,
     VERSION1 = 548,
     PLAINTEXT = 549,
     MD5 = 550,
     HONOR = 551,
     NEVER = 552,
     ALWAYS = 553,
     RIP_METRIC = 554,
     RIP_TAG = 555,
     STATIC = 556,
     PROHIBIT = 557,
     MULTIPATH = 558
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 236 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;



/* Line 214 of yacc.c  */
#line 677 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 689 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  54
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2031

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  325
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  216
/* YYNRULES -- Number of rules.  */
#define YYNRULES  674
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1274

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   558

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    30,     2,     2,     2,    29,     2,     2,
     315,   316,    27,    25,   321,    26,    31,    28,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   318,   317,
      22,    21,    23,   322,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   323,     2,   324,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   319,     2,   320,    24,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      51,    53,    55,    58,    61,    63,    65,    66,    71,    74,
      75,    77,    80,    82,    84,    88,    90,    94,    96,    98,
     100,   102,   104,   106,   108,   110,   112,   117,   121,   123,
     125,   127,   129,   132,   137,   141,   145,   149,   153,   158,
     161,   162,   164,   167,   170,   174,   177,   181,   184,   188,
     192,   196,   201,   203,   205,   207,   212,   213,   216,   219,
     222,   224,   226,   229,   231,   232,   234,   235,   238,   241,
     244,   247,   250,   253,   256,   260,   263,   266,   268,   270,
     272,   274,   278,   282,   283,   285,   287,   290,   291,   293,
     297,   299,   303,   306,   310,   314,   318,   319,   323,   325,
     327,   331,   333,   337,   339,   341,   343,   345,   347,   349,
     351,   353,   357,   359,   363,   365,   367,   372,   374,   375,
     379,   384,   386,   389,   390,   396,   402,   408,   414,   419,
     423,   427,   432,   438,   440,   441,   445,   450,   455,   456,
     459,   463,   467,   471,   474,   477,   480,   484,   488,   491,
     494,   496,   498,   503,   507,   511,   515,   519,   523,   527,
     531,   536,   538,   540,   542,   543,   545,   549,   553,   557,
     561,   566,   571,   576,   581,   584,   586,   588,   590,   592,
     593,   595,   596,   601,   604,   606,   608,   610,   612,   614,
     616,   618,   620,   622,   624,   627,   630,   631,   635,   637,
     641,   643,   645,   647,   650,   654,   657,   662,   663,   669,
     670,   672,   674,   677,   679,   683,   685,   687,   689,   691,
     693,   699,   708,   721,   727,   733,   739,   741,   746,   748,
     752,   756,   758,   761,   764,   771,   773,   777,   778,   783,
     787,   789,   793,   797,   801,   804,   807,   810,   813,   814,
     817,   820,   821,   827,   829,   831,   833,   835,   837,   839,
     841,   845,   849,   851,   853,   854,   859,   861,   863,   865,
     867,   869,   871,   873,   875,   877,   881,   885,   889,   893,
     897,   901,   905,   909,   913,   917,   921,   925,   929,   933,
     936,   941,   943,   945,   947,   949,   952,   955,   959,   963,
     970,   974,   978,   982,   986,   993,  1000,  1007,  1012,  1014,
    1016,  1018,  1020,  1022,  1024,  1026,  1027,  1029,  1033,  1035,
    1039,  1040,  1042,  1047,  1054,  1059,  1063,  1069,  1075,  1080,
    1087,  1091,  1094,  1100,  1106,  1115,  1124,  1133,  1136,  1140,
    1144,  1150,  1157,  1164,  1171,  1176,  1181,  1187,  1194,  1201,
    1207,  1211,  1216,  1222,  1228,  1234,  1240,  1245,  1250,  1256,
    1262,  1268,  1274,  1280,  1286,  1292,  1299,  1306,  1315,  1322,
    1329,  1335,  1340,  1346,  1351,  1357,  1362,  1368,  1374,  1377,
    1381,  1385,  1387,  1390,  1393,  1398,  1401,  1403,  1406,  1411,
    1412,  1416,  1420,  1423,  1428,  1431,  1434,  1436,  1441,  1443,
    1445,  1446,  1450,  1453,  1456,  1459,  1464,  1466,  1467,  1471,
    1472,  1475,  1478,  1482,  1485,  1488,  1492,  1495,  1498,  1501,
    1503,  1507,  1510,  1513,  1516,  1519,  1522,  1525,  1529,  1532,
    1535,  1538,  1541,  1544,  1547,  1550,  1553,  1557,  1560,  1564,
    1567,  1571,  1575,  1580,  1583,  1586,  1589,  1593,  1597,  1601,
    1603,  1604,  1607,  1609,  1611,  1614,  1618,  1619,  1622,  1624,
    1626,  1629,  1633,  1634,  1635,  1639,  1640,  1644,  1648,  1650,
    1651,  1656,  1663,  1670,  1677,  1685,  1692,  1700,  1707,  1710,
    1714,  1718,  1724,  1729,  1734,  1737,  1739,  1742,  1745,  1746,
    1750,  1755,  1756,  1761,  1766,  1770,  1773,  1777,  1781,  1785,
    1789,  1794,  1798,  1801,  1802,  1803,  1807,  1808,  1812,  1817,
    1819,  1822,  1825,  1828,  1832,  1836,  1837,  1838,  1842,  1843,
    1847,  1851,  1854,  1858,  1862,  1867,  1872,  1877,  1883,  1889,
    1894,  1898,  1903,  1908,  1913,  1918,  1920,  1922,  1924,  1926,
    1928,  1930,  1932,  1934,  1935,  1938,  1941,  1942,  1946,  1947,
    1951,  1952,  1956,  1959,  1963,  1967,  1973,  1977,  1980,  1983,
    1987,  1989,  1992,  1996,  2000,  2004,  2007,  2010,  2013,  2018,
    2020,  2022,  2024,  2026,  2028,  2030,  2032,  2034,  2036,  2038,
    2040,  2042,  2044,  2046,  2048,  2050,  2052,  2054,  2056,  2058,
    2060,  2062,  2064,  2066,  2068,  2070,  2072,  2074,  2076,  2078,
    2080,  2082,  2084,  2086,  2088,  2090,  2092,  2094,  2096,  2098,
    2100,  2102,  2104,  2106,  2108,  2110,  2112,  2114,  2116,  2118,
    2121,  2124,  2127,  2130,  2133,  2136,  2139,  2142,  2145,  2149,
    2153,  2157,  2161,  2165,  2169,  2173,  2175,  2177,  2179,  2181,
    2183,  2185,  2187,  2189,  2191,  2193,  2195,  2197,  2199,  2201,
    2203,  2205,  2207,  2209,  2211
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     326,     0,    -1,   327,     3,    -1,     4,   536,    -1,    -1,
     327,   535,    -1,    14,    -1,   315,   455,   316,    -1,    18,
      -1,    32,    18,    21,   328,   317,    -1,    32,    18,    21,
      17,   317,    -1,   328,    -1,    33,    -1,    35,    -1,    34,
      -1,    36,    -1,    -1,    17,    -1,    18,    -1,   331,   334,
      -1,   332,    -1,   331,    -1,    28,   328,    -1,   318,   331,
      -1,    19,    -1,    19,    -1,    -1,    37,   339,   340,   317,
      -1,    56,    19,    -1,    -1,    19,    -1,    38,   338,    -1,
      49,    -1,    39,    -1,   319,   341,   320,    -1,   342,    -1,
     341,   321,   342,    -1,    40,    -1,    41,    -1,    42,    -1,
      43,    -1,    44,    -1,    45,    -1,    46,    -1,    47,    -1,
      48,    -1,   109,    89,   380,   317,    -1,   109,    19,   317,
      -1,   117,    -1,    72,    -1,    55,    -1,    37,    -1,   344,
      19,    -1,   344,    19,   328,    19,    -1,   344,    52,    53,
      -1,   344,    52,    54,    -1,    51,   345,   317,    -1,    57,
     350,     3,    -1,    57,    50,   350,     3,    -1,    58,     3,
      -1,    -1,    19,    -1,   362,    59,    -1,    60,   330,    -1,
      61,    62,   328,    -1,    63,   330,    -1,    64,    65,   330,
      -1,   362,    64,    -1,    61,    62,   328,    -1,    91,   336,
     333,    -1,    59,    67,   328,    -1,    70,    71,   357,   317,
      -1,    14,    -1,    16,    -1,    17,    -1,    98,    99,   359,
     317,    -1,    -1,   359,   360,    -1,   102,   331,    -1,   103,
     328,    -1,   100,    -1,   101,    -1,    67,    18,    -1,    72,
      -1,    -1,    18,    -1,    -1,    73,   328,    -1,    74,   330,
      -1,    40,   377,    -1,   109,   380,    -1,    77,   365,    -1,
      78,   365,    -1,    67,   366,    -1,    70,    71,   357,    -1,
     105,    19,    -1,    79,   428,    -1,   429,    -1,    39,    -1,
      80,    -1,    18,    -1,    40,    89,   377,    -1,    40,    95,
     328,    -1,    -1,    19,    -1,   333,    -1,    19,   333,    -1,
      -1,    26,    -1,   368,   370,   369,    -1,   371,    -1,   372,
     321,   371,    -1,   362,    75,    -1,   373,   363,   319,    -1,
     374,   364,   317,    -1,   374,   376,   317,    -1,    -1,    76,
     375,   372,    -1,    39,    -1,    34,    -1,   319,   378,   320,
      -1,   379,    -1,   378,   321,   379,    -1,    81,    -1,    65,
      -1,    82,    -1,    90,    -1,    87,    -1,    88,    -1,    39,
      -1,    34,    -1,   319,   381,   320,    -1,   382,    -1,   381,
     321,   382,    -1,    81,    -1,   110,    -1,   104,   319,   384,
     320,    -1,   385,    -1,    -1,   385,   317,   384,    -1,   386,
     319,   387,   320,    -1,   386,    -1,    83,    19,    -1,    -1,
      97,    84,   335,   317,   387,    -1,    97,    86,   335,   317,
     387,    -1,   133,    84,   335,   317,   387,    -1,   133,    86,
     335,   317,   387,    -1,    71,   328,   317,   387,    -1,   114,
     115,     3,    -1,   114,   112,     3,    -1,   114,    89,   419,
       3,    -1,   114,    89,    39,   419,     3,    -1,    18,    -1,
      -1,   114,    90,     3,    -1,   114,    90,   116,     3,    -1,
     114,   117,   396,     3,    -1,    -1,   396,   332,    -1,   396,
      94,   333,    -1,   396,    67,    18,    -1,   396,    79,   428,
      -1,   396,   429,    -1,   396,    39,    -1,   396,    91,    -1,
     396,   397,    18,    -1,   396,    72,    18,    -1,   396,    92,
      -1,   396,    93,    -1,    96,    -1,    78,    -1,   114,   118,
     392,     3,    -1,   119,   120,     3,    -1,   119,   121,     3,
      -1,   119,    90,     3,    -1,   119,   122,     3,    -1,   119,
     123,     3,    -1,   119,    65,     3,    -1,   119,    89,     3,
      -1,   124,   407,   408,     3,    -1,    39,    -1,    34,    -1,
      14,    -1,    -1,    14,    -1,   125,   418,     3,    -1,   126,
     418,     3,    -1,   127,   418,     3,    -1,   106,   418,     3,
      -1,   106,   107,   418,     3,    -1,   106,   108,   418,     3,
      -1,    40,   418,   377,     3,    -1,   109,   418,   380,     3,
      -1,   111,     3,    -1,    18,    -1,    39,    -1,    19,    -1,
      18,    -1,    -1,    19,    -1,    -1,    79,    18,   421,   427,
      -1,   173,   455,    -1,   136,    -1,   137,    -1,   138,    -1,
     139,    -1,   140,    -1,   141,    -1,   143,    -1,   144,    -1,
     145,    -1,   146,    -1,   423,   142,    -1,   423,    18,    -1,
      -1,   424,   317,   425,    -1,   424,    -1,   426,   317,   424,
      -1,   431,    -1,    18,    -1,   427,    -1,   172,   455,    -1,
     315,   426,   316,    -1,   315,   316,    -1,   425,   319,   434,
     320,    -1,    -1,   128,    18,   433,   430,   431,    -1,    -1,
     435,    -1,   461,    -1,   435,   461,    -1,   461,    -1,   319,
     434,   320,    -1,    17,    -1,   328,    -1,    16,    -1,   437,
      -1,    15,    -1,   315,   328,   321,   328,   316,    -1,   315,
     328,   321,   328,    31,    31,   328,   316,    -1,   315,   328,
     321,   328,   316,    31,    31,   315,   328,   321,   328,   316,
      -1,   315,    27,   321,    27,   316,    -1,   315,   328,   321,
      27,   316,    -1,   315,    27,   321,   328,   316,    -1,   438,
      -1,   438,    31,    31,   438,    -1,   439,    -1,   440,   321,
     439,    -1,    17,    28,    14,    -1,   441,    -1,   441,    25,
      -1,   441,    26,    -1,   441,   319,    14,   321,    14,   320,
      -1,   442,    -1,   443,   321,   442,    -1,    -1,   444,   439,
     318,   434,    -1,   444,     6,   434,    -1,   453,    -1,   315,
     455,   316,    -1,    12,   447,    13,    -1,    28,   448,    28,
      -1,    14,   447,    -1,    27,   447,    -1,   322,   447,    -1,
     445,   447,    -1,    -1,    14,   448,    -1,   322,   448,    -1,
      -1,   315,   455,   321,   455,   316,    -1,    14,    -1,   151,
      -1,   152,    -1,    19,    -1,   437,    -1,   441,    -1,    16,
      -1,   323,   440,   324,    -1,   323,   443,   324,    -1,    15,
      -1,   446,    -1,    -1,    18,   315,   460,   316,    -1,    18,
      -1,    84,    -1,   153,    -1,   154,    -1,   156,    -1,   157,
      -1,   158,    -1,   159,    -1,   160,    -1,   315,   455,   316,
      -1,   455,    25,   455,    -1,   455,    26,   455,    -1,   455,
      27,   455,    -1,   455,    28,   455,    -1,   455,    10,   455,
      -1,   455,    11,   455,    -1,   455,    21,   455,    -1,   455,
       9,   455,    -1,   455,    22,   455,    -1,   455,     8,   455,
      -1,   455,    23,   455,    -1,   455,     7,   455,    -1,   455,
      24,   455,    -1,    30,   455,    -1,   162,   315,   455,   316,
      -1,   453,    -1,   450,    -1,   449,    -1,    73,    -1,   451,
     454,    -1,   451,   540,    -1,   455,    31,   138,    -1,   455,
      31,   161,    -1,   455,    31,   155,   315,   455,   316,    -1,
     455,    31,   168,    -1,   455,    31,   169,    -1,    25,   171,
      25,    -1,    26,   171,    26,    -1,   167,   315,   455,   321,
     455,   316,    -1,   163,   315,   455,   321,   455,   316,    -1,
     164,   315,   455,   321,   455,   316,    -1,    18,   315,   460,
     316,    -1,   135,    -1,   133,    -1,   134,    -1,    45,    -1,
     129,    -1,   130,    -1,   455,    -1,    -1,   457,    -1,   457,
     321,   458,    -1,   455,    -1,   455,   321,   459,    -1,    -1,
     459,    -1,   147,   455,   148,   436,    -1,   147,   455,   148,
     436,   149,   436,    -1,    18,    21,   455,   317,    -1,   132,
     455,   317,    -1,   451,   540,    21,   455,   317,    -1,   451,
     454,    21,   455,   317,    -1,    73,    21,   455,   317,    -1,
     131,   315,   451,   540,   316,   317,    -1,   456,   458,   317,
      -1,   452,   317,    -1,   150,   455,   319,   444,   320,    -1,
     451,   540,    31,   171,   317,    -1,   451,   540,    31,   167,
     315,   455,   316,   317,    -1,   451,   540,    31,   163,   315,
     455,   316,   317,    -1,   451,   540,    31,   164,   315,   455,
     316,   317,    -1,   362,    99,    -1,   462,   363,   319,    -1,
     463,   364,   317,    -1,   463,   174,   176,   328,   317,    -1,
     463,   174,   331,   176,   328,   317,    -1,   463,   175,   331,
     176,   328,   317,    -1,   463,   203,   206,    71,   357,   317,
      -1,   463,   203,   205,   317,    -1,   463,   204,   205,   317,
      -1,   463,   177,    62,   328,   317,    -1,   463,   182,   177,
      62,   328,   317,    -1,   463,   178,   179,    62,   328,   317,
      -1,   463,   180,    62,   328,   317,    -1,   463,   181,   317,
      -1,   463,   181,   328,   317,    -1,   463,   184,   185,   186,
     317,    -1,   463,   214,   215,   186,   317,    -1,   463,   214,
     215,   216,   317,    -1,   463,   214,   215,   217,   317,    -1,
     463,   224,    75,   317,    -1,   463,   224,   225,   317,    -1,
     463,   188,   189,   330,   317,    -1,   463,   226,   189,   330,
     317,    -1,   463,   223,   189,   330,   317,    -1,   463,   212,
     213,   330,   317,    -1,   463,   187,   197,   328,   317,    -1,
     463,   187,   196,   328,   317,    -1,   463,   157,   102,   331,
     317,    -1,   463,   190,   191,    62,   328,   317,    -1,   463,
      45,   192,    62,   328,   317,    -1,   463,    45,   193,    62,
     328,   321,   328,   317,    -1,   463,   125,   194,    45,   330,
     317,    -1,   463,   126,   117,   218,   330,   317,    -1,   463,
     126,   207,   330,   317,    -1,   463,   210,   330,   317,    -1,
     463,   208,   209,   330,   317,    -1,   463,    83,    19,   317,
      -1,   463,   117,   211,   328,   317,    -1,   463,    85,   330,
     317,    -1,   463,   219,   220,   330,   317,    -1,   463,   223,
      67,   366,   317,    -1,   362,   227,    -1,   464,   363,   319,
      -1,   465,   466,   317,    -1,   364,    -1,   233,   330,    -1,
     268,   330,    -1,   268,   330,   211,   328,    -1,   235,   328,
      -1,   468,    -1,   228,   357,    -1,   467,   319,   469,   320,
      -1,    -1,   469,   470,   317,    -1,   234,   236,   328,    -1,
     234,   330,    -1,   257,   319,   480,   320,    -1,   266,   471,
      -1,    76,   491,    -1,   475,    -1,   472,   319,   473,   320,
      -1,   472,    -1,   332,    -1,    -1,   473,   474,   317,    -1,
     258,   330,    -1,   116,   330,    -1,   236,   328,    -1,   478,
     319,   476,   320,    -1,   478,    -1,    -1,   476,   477,   317,
      -1,    -1,   238,   328,    -1,   237,   328,    -1,   239,   191,
     328,    -1,   193,   328,    -1,   241,   328,    -1,   241,    93,
     328,    -1,   252,    80,    -1,   252,   251,    -1,   252,   254,
      -1,   383,    -1,   259,   261,   357,    -1,   236,   328,    -1,
     238,   328,    -1,   256,   328,    -1,   237,   328,    -1,   193,
     328,    -1,   241,   328,    -1,   241,    93,   328,    -1,   242,
     243,    -1,   242,   244,    -1,   242,   245,    -1,   242,   246,
      -1,   242,   247,    -1,   242,   248,    -1,   242,   249,    -1,
     242,   250,    -1,   239,   191,   328,    -1,   240,   328,    -1,
     253,   245,   330,    -1,   234,   330,    -1,   260,   261,   330,
      -1,   268,   269,   328,    -1,   122,   319,   484,   320,    -1,
     252,    80,    -1,   252,   251,    -1,   252,   254,    -1,   262,
     263,   264,    -1,   262,   263,   265,    -1,   262,   263,   328,
      -1,   383,    -1,    -1,   480,   481,    -1,   482,    -1,   483,
      -1,   332,   317,    -1,   332,   258,   317,    -1,    -1,   484,
     485,    -1,   486,    -1,   487,    -1,    17,   317,    -1,    17,
     255,   317,    -1,    -1,    -1,   489,   479,   317,    -1,    -1,
     319,   489,   320,    -1,   488,   372,   490,    -1,    19,    -1,
      -1,   114,   227,   392,     3,    -1,   114,   227,   122,   392,
     492,     3,    -1,   114,   227,    76,   392,   492,     3,    -1,
     114,   227,   270,   392,   492,     3,    -1,   114,   227,   270,
      39,   392,   492,     3,    -1,   114,   227,   271,   392,   492,
       3,    -1,   114,   227,   271,    39,   392,   492,     3,    -1,
     114,   227,   267,   392,   492,     3,    -1,   362,   272,    -1,
     501,   363,   319,    -1,   502,   364,   317,    -1,   502,   273,
      67,    18,   317,    -1,   502,   274,   275,   317,    -1,   502,
     274,   276,   317,    -1,   362,   277,    -1,   364,    -1,   139,
     518,    -1,    76,   512,    -1,    -1,   505,   504,   317,    -1,
     503,   363,   319,   505,    -1,    -1,   278,   280,   281,   328,
      -1,   279,   280,   281,   328,    -1,   278,   191,   328,    -1,
     282,   330,    -1,   283,   284,   330,    -1,   261,   285,   328,
      -1,   286,    62,   328,    -1,   287,   288,   328,    -1,   289,
     185,   211,   328,    -1,   187,   292,   328,    -1,   139,   518,
      -1,    -1,    -1,   510,   508,   317,    -1,    -1,   319,   510,
     320,    -1,   507,   372,   511,   509,    -1,   332,    -1,   293,
     330,    -1,   294,   330,    -1,   295,   330,    -1,   290,   292,
     328,    -1,   291,   292,   328,    -1,    -1,    -1,   516,   514,
     317,    -1,    -1,   319,   516,   320,    -1,   513,   517,   515,
      -1,   362,   296,    -1,   519,   363,   319,    -1,   520,   364,
     317,    -1,   520,   297,   328,   317,    -1,   520,   103,   328,
     317,    -1,   520,   298,   328,   317,    -1,   520,   299,    62,
     328,   317,    -1,   520,   300,    62,   328,   317,    -1,   520,
     252,   521,   317,    -1,   520,   383,   317,    -1,   520,   307,
     309,   317,    -1,   520,   307,   175,   317,    -1,   520,   307,
     308,   317,    -1,   520,    76,   527,   317,    -1,   305,    -1,
     306,    -1,    80,    -1,   243,    -1,   301,    -1,   302,    -1,
     303,    -1,   304,    -1,    -1,   189,   328,    -1,   274,   522,
      -1,    -1,   524,   523,   317,    -1,    -1,   319,   524,   320,
      -1,    -1,   526,   372,   525,    -1,   362,   312,    -1,   528,
     363,   319,    -1,   529,   364,   317,    -1,   529,   260,   261,
     330,   317,    -1,   529,   533,   317,    -1,   117,   332,    -1,
     183,   331,    -1,   531,   269,   328,    -1,   531,    -1,   532,
     531,    -1,   530,   183,   331,    -1,   530,   183,    19,    -1,
     530,   314,   532,    -1,   530,   216,    -1,   530,   134,    -1,
     530,   313,    -1,   114,   312,   392,     3,    -1,   317,    -1,
     329,    -1,   337,    -1,   343,    -1,   346,    -1,   356,    -1,
     358,    -1,   361,    -1,   537,    -1,   367,    -1,   420,    -1,
     422,    -1,   432,    -1,   347,    -1,   348,    -1,   349,    -1,
     388,    -1,   389,    -1,   390,    -1,   391,    -1,   393,    -1,
     394,    -1,   395,    -1,   398,    -1,   399,    -1,   400,    -1,
     401,    -1,   402,    -1,   403,    -1,   404,    -1,   405,    -1,
     406,    -1,   409,    -1,   410,    -1,   411,    -1,   412,    -1,
     413,    -1,   414,    -1,   415,    -1,   416,    -1,   417,    -1,
     493,    -1,   494,    -1,   495,    -1,   496,    -1,   497,    -1,
     498,    -1,   499,    -1,   500,    -1,   534,    -1,   538,   320,
      -1,   539,   320,    -1,   374,   320,    -1,   463,   320,    -1,
     465,   320,    -1,   502,   320,    -1,   506,   320,    -1,   520,
     320,    -1,   529,   320,    -1,   351,   363,   319,    -1,   538,
     364,   317,    -1,   538,   352,   317,    -1,   538,   355,   317,
      -1,   353,   363,   319,    -1,   539,   364,   317,    -1,   539,
     354,   317,    -1,    68,    -1,    69,    -1,   113,    -1,     5,
      -1,   198,    -1,   195,    -1,   199,    -1,   197,    -1,   196,
      -1,   200,    -1,   201,    -1,   202,    -1,   221,    -1,   222,
      -1,   229,    -1,   230,    -1,   231,    -1,   232,    -1,   310,
      -1,   311,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   400,   400,   401,   404,   406,   413,   414,   415,   419,
     423,   432,   433,   434,   435,   436,   437,   443,   444,   451,
     458,   459,   463,   467,   474,   482,   483,   489,   498,   499,
     503,   508,   509,   513,   514,   518,   519,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   537,   538,   547,   548,
     549,   550,   553,   554,   555,   556,   560,   567,   570,   573,
     577,   578,   586,   602,   603,   607,   614,   620,   633,   637,
     650,   663,   669,   670,   671,   682,   684,   686,   690,   691,
     692,   693,   700,   708,   712,   718,   724,   726,   730,   731,
     732,   733,   734,   735,   736,   737,   741,   742,   743,   744,
     748,   756,   757,   765,   773,   774,   775,   779,   780,   784,
     789,   790,   797,   806,   807,   808,   812,   821,   827,   828,
     829,   833,   834,   838,   839,   840,   841,   842,   843,   849,
     850,   851,   855,   856,   860,   861,   867,   868,   871,   873,
     877,   878,   882,   900,   901,   902,   903,   904,   905,   913,
     916,   919,   922,   926,   927,   930,   933,   936,   940,   946,
     952,   959,   964,   969,   974,   978,   982,   992,  1000,  1004,
    1011,  1012,  1015,  1019,  1021,  1023,  1025,  1027,  1029,  1031,
    1034,  1040,  1041,  1042,  1046,  1047,  1053,  1055,  1057,  1059,
    1061,  1063,  1067,  1071,  1074,  1078,  1079,  1080,  1084,  1085,
    1086,  1094,  1094,  1104,  1108,  1109,  1110,  1111,  1112,  1113,
    1114,  1115,  1116,  1117,  1118,  1138,  1149,  1150,  1157,  1158,
    1165,  1174,  1178,  1182,  1206,  1207,  1211,  1224,  1224,  1240,
    1241,  1244,  1245,  1249,  1252,  1261,  1265,  1266,  1267,  1268,
    1272,  1278,  1284,  1290,  1296,  1302,  1309,  1314,  1322,  1323,
    1327,  1334,  1335,  1336,  1337,  1344,  1345,  1348,  1349,  1354,
    1366,  1367,  1371,  1372,  1376,  1377,  1378,  1379,  1380,  1384,
    1385,  1386,  1390,  1403,  1404,  1405,  1406,  1407,  1408,  1409,
    1410,  1411,  1412,  1413,  1423,  1427,  1450,  1484,  1486,  1487,
    1488,  1489,  1490,  1491,  1492,  1496,  1497,  1498,  1499,  1500,
    1501,  1502,  1503,  1504,  1505,  1506,  1507,  1508,  1509,  1510,
    1511,  1513,  1514,  1515,  1517,  1519,  1521,  1523,  1524,  1525,
    1526,  1527,  1537,  1538,  1539,  1540,  1541,  1546,  1569,  1570,
    1571,  1572,  1573,  1574,  1578,  1581,  1582,  1583,  1592,  1599,
    1608,  1609,  1613,  1619,  1629,  1638,  1644,  1649,  1656,  1661,
    1667,  1668,  1669,  1677,  1679,  1680,  1681,  1687,  1709,  1710,
    1711,  1712,  1713,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1763,  1774,
    1775,  1779,  1780,  1781,  1782,  1783,  1784,  1787,  1798,  1801,
    1803,  1807,  1808,  1809,  1810,  1811,  1812,  1816,  1817,  1821,
    1829,  1831,  1835,  1836,  1837,  1841,  1842,  1845,  1847,  1850,
    1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,
    1863,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,
    1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,
    1916,  1918,  1922,  1923,  1925,  1934,  1944,  1946,  1950,  1951,
    1953,  1962,  1973,  1993,  1995,  1998,  2000,  2004,  2008,  2009,
    2013,  2016,  2019,  2024,  2027,  2032,  2035,  2038,  2044,  2052,
    2053,  2054,  2059,  2060,  2066,  2074,  2075,  2076,  2079,  2081,
    2085,  2089,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,
    2111,  2112,  2113,  2117,  2135,  2137,  2140,  2142,  2146,  2149,
    2162,  2163,  2164,  2165,  2166,  2170,  2175,  2177,  2180,  2182,
    2186,  2192,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
    2207,  2208,  2209,  2210,  2211,  2215,  2216,  2217,  2222,  2223,
    2224,  2225,  2226,  2229,  2230,  2231,  2234,  2236,  2239,  2241,
    2245,  2254,  2261,  2268,  2269,  2270,  2271,  2274,  2283,  2290,
    2297,  2298,  2302,  2306,  2312,  2315,  2316,  2317,  2320,  2327,
    2327,  2327,  2327,  2327,  2327,  2327,  2327,  2327,  2327,  2327,
    2327,  2327,  2328,  2328,  2328,  2328,  2328,  2328,  2328,  2328,
    2328,  2328,  2328,  2328,  2328,  2328,  2328,  2328,  2328,  2328,
    2328,  2328,  2328,  2328,  2328,  2328,  2328,  2328,  2328,  2328,
    2328,  2328,  2328,  2328,  2328,  2328,  2328,  2328,  2328,  2329,
    2329,  2329,  2329,  2329,  2329,  2329,  2329,  2329,  2330,  2330,
    2330,  2330,  2331,  2331,  2331,  2332,  2332,  2332,  2333,  2333,
    2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,  2342,  2343,
    2343,  2343,  2343,  2343,  2343
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM", "ENUM",
  "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'", "'>'",
  "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE", "ON",
  "OFF", "YES", "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO",
  "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR", "SOFT",
  "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME", "CONFIGURE",
  "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES",
  "ASYNC", "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL",
  "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT", "EXPORT",
  "FILTER", "NONE", "STATES", "FILTERS", "PASSWORD", "FROM", "PASSIVE",
  "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES", "PRIMARY", "STATS",
  "COUNT", "FOR", "COMMANDS", "PREEXPORT", "GENERATE", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION",
  "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY",
  "IGP_METRIC", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "ECHO", "DISABLE",
  "ENABLE", "RESTART", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN",
  "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR",
  "QUAD", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "IF", "THEN",
  "ELSE", "CASE", "TRUE", "FALSE", "GW", "NET", "MASK", "PROTO", "SOURCE",
  "SCOPE", "CAST", "DEST", "LEN", "DEFINED", "ADD", "DELETE", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "MATCH", "EMPTY", "WHERE", "EVAL",
  "LOCAL", "NEIGHBOR", "AS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE",
  "MULTIHOP", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH",
  "METRIC", "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "IPV4", "CAPABILITIES", "LIMIT",
  "PREFER", "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH",
  "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST",
  "IGP", "GATEWAY", "RECURSIVE", "MED", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD",
  "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT",
  "PTP", "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "CHECK", "LINK", "RX", "BUFFER", "LARGE", "NORMAL", "STUBNET", "LSADB",
  "ECMP", "WEIGHT", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE",
  "TRANSPARENT", "RADV", "MIN", "MAX", "RA", "INTERVAL", "MANAGED",
  "OTHER", "CONFIG", "MTU", "REACHABLE", "RETRANS", "TIMER", "CURRENT",
  "VALID", "PREFERRED", "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS", "RIP",
  "INFINITY", "PERIOD", "GARBAGE", "TIMEOUT", "MULTICAST", "QUIET",
  "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS",
  "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "'('", "')'",
  "';'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "expr", "definition", "bool", "ipa", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text_or_none", "log_config",
  "syslog_name", "log_file", "log_mask", "log_mask_list", "log_cat",
  "mrtdump_base", "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_DOWN", "cfg_name",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "nl_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "newtab", "proto_start", "proto_name", "proto_item", "imexport",
  "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "mrtdump_mask", "mrtdump_list", "mrtdump_flag", "password_list",
  "password_items", "password_item", "password_item_begin",
  "password_item_params", "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY",
  "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL", "optsym",
  "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE",
  "r_args", "export_or_preexport", "cmd_SHOW_SYMBOLS",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "set_item", "set_items", "fprefix_s", "fprefix", "fprefix_set",
  "switch_body", "bgp_path_expr", "bgp_path", "bgp_path_tail1",
  "bgp_path_tail2", "dpair", "constant", "rtadot", "function_call",
  "symbol", "static_attr", "term", "break_command", "print_one",
  "print_list", "var_listn", "var_list", "cmd", "bgp_proto_start",
  "bgp_proto", "ospf_proto_start", "ospf_proto", "ospf_proto_item",
  "ospf_area_start", "ospf_area", "ospf_area_opts", "ospf_area_item",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_el", "pref_hid", "ipa_list", "ipa_item", "ipa_el", "ipa_ne",
  "ospf_iface_start", "ospf_iface_opts", "ospf_iface_opt_list",
  "ospf_iface", "opttext", "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS",
  "cmd_SHOW_OSPF_INTERFACE", "cmd_SHOW_OSPF_TOPOLOGY",
  "cmd_SHOW_OSPF_TOPOLOGY_ALL", "cmd_SHOW_OSPF_STATE",
  "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB", "pipe_proto_start",
  "pipe_proto", "radv_proto_start", "radv_proto_item", "radv_proto_opts",
  "radv_proto", "radv_iface_start", "radv_iface_item", "radv_iface_finish",
  "radv_iface_opts", "radv_iface_opt_list", "radv_iface",
  "radv_prefix_start", "radv_prefix_item", "radv_prefix_finish",
  "radv_prefix_opts", "radv_prefix_opt_list", "radv_prefix",
  "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,    61,    60,    62,   126,    43,    45,    42,    47,    37,
      33,    46,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,    40,    41,    59,    58,   123,
     125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   325,   326,   326,   327,   327,   328,   328,   328,   329,
     329,   330,   330,   330,   330,   330,   330,   331,   331,   332,
     333,   333,   334,   334,   335,   336,   336,   337,   338,   338,
     339,   339,   339,   340,   340,   341,   341,   342,   342,   342,
     342,   342,   342,   342,   342,   342,   343,   343,   344,   344,
     344,   344,   345,   345,   345,   345,   346,   347,   348,   349,
     350,   350,   351,   352,   352,   352,   352,   353,   354,   354,
     355,   356,   357,   357,   357,   358,   359,   359,   360,   360,
     360,   360,   361,   362,   363,   363,   364,   364,   364,   364,
     364,   364,   364,   364,   364,   364,   365,   365,   365,   365,
     366,   367,   367,   368,   369,   369,   369,   370,   370,   371,
     372,   372,   373,   374,   374,   374,   375,   376,   377,   377,
     377,   378,   378,   379,   379,   379,   379,   379,   379,   380,
     380,   380,   381,   381,   382,   382,   383,   383,   384,   384,
     385,   385,   386,   387,   387,   387,   387,   387,   387,   388,
     389,   390,   391,   392,   392,   393,   394,   395,   396,   396,
     396,   396,   396,   396,   396,   396,   396,   396,   396,   396,
     397,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   407,   407,   408,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   418,   418,   419,   419,
     419,   421,   420,   422,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   424,   425,   425,   426,   426,
     427,   428,   428,   429,   430,   430,   431,   433,   432,   434,
     434,   435,   435,   436,   436,   437,   438,   438,   438,   438,
     439,   439,   439,   439,   439,   439,   439,   439,   440,   440,
     441,   442,   442,   442,   442,   443,   443,   444,   444,   444,
     445,   445,   446,   446,   447,   447,   447,   447,   447,   448,
     448,   448,   449,   450,   450,   450,   450,   450,   450,   450,
     450,   450,   450,   450,   451,   452,   453,   454,   454,   454,
     454,   454,   454,   454,   454,   455,   455,   455,   455,   455,
     455,   455,   455,   455,   455,   455,   455,   455,   455,   455,
     455,   455,   455,   455,   455,   455,   455,   455,   455,   455,
     455,   455,   455,   455,   455,   455,   455,   455,   456,   456,
     456,   456,   456,   456,   457,   458,   458,   458,   459,   459,
     460,   460,   461,   461,   461,   461,   461,   461,   461,   461,
     461,   461,   461,   461,   461,   461,   461,   462,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   464,   465,
     465,   466,   466,   466,   466,   466,   466,   467,   468,   469,
     469,   470,   470,   470,   470,   470,   470,   471,   471,   472,
     473,   473,   474,   474,   474,   475,   475,   476,   476,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     478,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     480,   480,   481,   481,   482,   483,   484,   484,   485,   485,
     486,   487,   488,   489,   489,   490,   490,   491,   492,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     502,   502,   502,   502,   503,   504,   504,   504,   505,   505,
     506,   507,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   509,   510,   510,   511,   511,   512,   513,
     514,   514,   514,   514,   514,   515,   516,   516,   517,   517,
     518,   519,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   520,   520,   520,   520,   521,   521,   521,   522,   522,
     522,   522,   522,   523,   523,   523,   524,   524,   525,   525,
     526,   527,   528,   529,   529,   529,   529,   530,   531,   531,
     532,   532,   533,   533,   533,   533,   533,   533,   534,   535,
     535,   535,   535,   535,   535,   535,   535,   535,   535,   535,
     535,   535,   536,   536,   536,   536,   536,   536,   536,   536,
     536,   536,   536,   536,   536,   536,   536,   536,   536,   536,
     536,   536,   536,   536,   536,   536,   536,   536,   536,   536,
     536,   536,   536,   536,   536,   536,   536,   536,   536,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   538,   538,
     538,   538,   539,   539,   539,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       1,     1,     2,     2,     1,     1,     0,     4,     2,     0,
       1,     2,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     3,     1,     1,
       1,     1,     2,     4,     3,     3,     3,     3,     4,     2,
       0,     1,     2,     2,     3,     2,     3,     2,     3,     3,
       3,     4,     1,     1,     1,     4,     0,     2,     2,     2,
       1,     1,     2,     1,     0,     1,     0,     2,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     1,     1,     1,
       1,     3,     3,     0,     1,     1,     2,     0,     1,     3,
       1,     3,     2,     3,     3,     3,     0,     3,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     4,     1,     0,     3,
       4,     1,     2,     0,     5,     5,     5,     5,     4,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     3,     3,     2,     2,
       1,     1,     4,     3,     3,     3,     3,     3,     3,     3,
       4,     1,     1,     1,     0,     1,     3,     3,     3,     3,
       4,     4,     4,     4,     2,     1,     1,     1,     1,     0,
       1,     0,     4,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     0,     3,     1,     3,
       1,     1,     1,     2,     3,     2,     4,     0,     5,     0,
       1,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       5,     8,    12,     5,     5,     5,     1,     4,     1,     3,
       3,     1,     2,     2,     6,     1,     3,     0,     4,     3,
       1,     3,     3,     3,     2,     2,     2,     2,     0,     2,
       2,     0,     5,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     1,     1,     0,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       4,     1,     1,     1,     1,     2,     2,     3,     3,     6,
       3,     3,     3,     3,     6,     6,     6,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     1,     3,
       0,     1,     4,     6,     4,     3,     5,     5,     4,     6,
       3,     2,     5,     5,     8,     8,     8,     2,     3,     3,
       5,     6,     6,     6,     4,     4,     5,     6,     6,     5,
       3,     4,     5,     5,     5,     5,     4,     4,     5,     5,
       5,     5,     5,     5,     5,     6,     6,     8,     6,     6,
       5,     4,     5,     4,     5,     4,     5,     5,     2,     3,
       3,     1,     2,     2,     4,     2,     1,     2,     4,     0,
       3,     3,     2,     4,     2,     2,     1,     4,     1,     1,
       0,     3,     2,     2,     2,     4,     1,     0,     3,     0,
       2,     2,     3,     2,     2,     3,     2,     2,     2,     1,
       3,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     2,     3,     2,
       3,     3,     4,     2,     2,     2,     3,     3,     3,     1,
       0,     2,     1,     1,     2,     3,     0,     2,     1,     1,
       2,     3,     0,     0,     3,     0,     3,     3,     1,     0,
       4,     6,     6,     6,     7,     6,     7,     6,     2,     3,
       3,     5,     4,     4,     2,     1,     2,     2,     0,     3,
       4,     0,     4,     4,     3,     2,     3,     3,     3,     3,
       4,     3,     2,     0,     0,     3,     0,     3,     4,     1,
       2,     2,     2,     3,     3,     0,     0,     3,     0,     3,
       3,     2,     3,     3,     4,     4,     4,     5,     5,     4,
       3,     4,     4,     4,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     2,     0,     3,     0,     3,
       0,     3,     2,     3,     3,     5,     3,     2,     2,     3,
       1,     2,     3,     3,     3,     2,     2,     2,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    60,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,     3,     1,     2,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,   284,   589,   590,
     591,   592,   593,    84,    84,   594,   595,   596,     0,   598,
      84,    86,   599,   600,   601,    84,    86,    84,    86,    84,
      86,    84,     0,    84,    86,    84,    86,     5,   597,    86,
      86,   195,   197,   196,     0,    61,    60,     0,    59,     0,
       0,     0,     0,   194,   199,     0,     0,     0,   158,   154,
     154,   154,     0,     0,     0,     0,     0,     0,     0,   183,
     182,   181,   184,     0,     0,     0,     0,    30,    29,    32,
       0,     0,     0,    51,    50,    49,    48,     0,     0,    82,
       0,   201,    76,     0,     0,   227,   268,   273,   282,   279,
     235,   286,   276,     0,     0,   271,   284,   314,   274,   275,
       0,     0,     0,     0,   284,     0,   277,   278,   283,   313,
     312,     0,   311,   203,    85,     0,     0,    62,    67,   112,
     357,   398,   498,   504,   541,   572,     0,     0,     0,     0,
       0,    16,   116,     0,     0,     0,     0,   641,     0,     0,
       0,     0,     0,    16,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    16,     0,     0,     0,     0,     0,     0,   642,
       0,     0,     0,    16,     0,    16,   643,   401,     0,     0,
     406,     0,     0,     0,   644,     0,     0,   645,     0,   570,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   646,
       0,     0,   137,   141,     0,     0,     0,   647,     0,     0,
       0,     0,    16,     0,    16,     0,   639,     0,     0,     0,
       0,    26,   640,     0,     0,   119,   118,     0,     0,     0,
      57,     0,     0,   189,   130,   129,     0,     0,   198,   200,
     199,     0,   155,     0,   150,   149,     0,   153,     0,   154,
     154,   154,   154,   154,     0,     0,   178,   179,   175,   173,
     174,   176,   177,   185,     0,   186,   187,   188,     0,     0,
      31,    33,     0,     0,   101,     6,     8,   284,   102,    52,
       0,    56,    72,    73,    74,     0,   216,     0,    47,     0,
       0,   268,   286,   268,   284,   268,   268,     0,   260,     0,
     284,     0,     0,   271,   271,     0,   309,   284,   284,   284,
     284,     0,   239,   237,   284,   236,   238,   246,   248,     0,
     251,   255,     0,   658,   655,   656,   287,   657,   288,   289,
     290,   291,   292,   293,   294,   660,   663,   662,   659,   661,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   315,   316,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,     0,   648,   652,   113,
      89,   100,    93,     0,    87,    12,    14,    13,    15,    11,
      88,   103,    98,   216,    99,   284,    91,    97,    92,    95,
      90,   114,   115,   358,     0,     0,     0,     0,     0,     0,
       0,    16,     0,    17,    18,     0,     0,     0,     0,     0,
       0,   370,     0,     0,     0,     0,     0,    16,     0,     0,
       0,     0,    16,     0,    16,     0,    16,     0,    16,     0,
       0,    16,   359,   399,   407,   402,   405,   403,   400,   409,
     499,     0,     0,     0,   500,   508,   542,   103,     0,   142,
       0,   138,   557,   555,   556,     0,     0,     0,     0,     0,
       0,     0,     0,   543,   550,   143,   573,     0,   577,    16,
     574,   586,     0,   585,   587,     0,   576,     0,    63,     0,
      65,    16,   650,   651,   649,     0,    25,     0,   654,   653,
     124,   123,   125,   127,   128,   126,     0,   121,   192,    58,
     190,   191,   134,   135,     0,   132,   193,     0,   151,   156,
     157,   164,     0,     0,   171,   216,   165,   168,   169,     0,
     170,   159,     0,   163,   172,   489,   489,   489,   154,   489,
     154,   489,   490,   588,   180,     0,     0,    28,    37,    38,
      39,    40,    41,    42,    43,    44,    45,     0,    35,    27,
       0,     0,    54,    55,    71,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,     0,     0,     0,   202,   220,
      80,    81,     0,     0,    75,    77,    46,     0,   216,   264,
     265,     0,   266,   267,   262,   250,   338,   341,     0,   322,
     323,   269,   270,   263,     0,     0,     0,     0,   295,   284,
     273,   286,     0,   284,     0,     0,     0,   280,   252,   253,
       0,     0,   281,   307,   305,   303,   300,   301,   302,   304,
     306,   308,   296,   297,   298,   299,   317,     0,   318,   320,
     321,    94,   107,   110,   117,   221,   222,    96,   223,     0,
       0,   393,   395,     0,    16,    16,     0,     0,     0,     0,
       0,     0,     0,     0,   371,     0,     0,     0,     0,     0,
       0,   364,     0,   365,     0,   391,     0,     0,     0,     0,
       0,     0,     0,   376,   377,     0,     0,     0,     0,   502,
     503,    86,   568,   554,   545,     0,     0,   549,   544,   546,
       0,     0,   552,   553,   551,     0,     0,     0,     0,     0,
       0,    19,     0,   583,   582,     0,   580,   584,    70,    64,
      66,    68,    21,    20,    69,   120,     0,   131,     0,   152,
     161,   167,   162,   160,   166,   488,     0,     0,     0,   489,
       0,   489,     0,    10,     9,    34,     0,     7,    53,   215,
     214,   216,   284,    78,    79,   225,   218,     0,   228,   261,
     284,   327,   310,   284,   284,   284,     0,     0,     0,     0,
       0,   235,   249,     0,     0,   256,   284,   108,     0,   103,
       0,     0,   394,     0,     0,   390,   384,   360,     0,     0,
     366,     0,   369,     0,   372,   383,   382,   378,     0,     0,
     392,   381,   373,   374,   375,   396,   397,   380,   379,   404,
     482,    16,     0,     0,     0,   408,     0,   416,   426,   501,
     511,     0,   505,     0,   566,   571,   136,   138,   547,   548,
       0,     0,     0,     0,     0,   140,    22,    23,   575,   578,
       0,   581,   122,   133,   492,   491,   497,     0,   493,     0,
     495,    36,   217,     0,   331,     0,   332,   333,     0,   284,
     329,   330,   328,   284,   284,     0,   284,     0,     0,   284,
     231,   224,     0,   339,     0,     0,     0,   272,     0,     0,
     295,     0,     0,   247,     0,     0,   104,   105,   109,   111,
     386,     0,   388,   389,   361,   362,   368,   367,   385,   363,
     103,   415,     0,   412,   470,     0,   419,   414,   418,   410,
     427,   103,   507,   529,   538,   506,   509,   563,   139,   143,
      24,     0,     0,     0,     0,   579,   494,   496,   284,   284,
     284,   284,     0,     0,     0,   226,   232,     0,     0,   351,
     334,   336,     0,   219,   325,   326,   324,   243,   245,   244,
       0,   240,     0,   319,   106,     0,   485,   411,     0,   440,
     420,   429,   526,   536,   535,     0,     0,   569,     0,   148,
     143,   143,   143,   143,     0,     0,     0,     0,   345,   284,
     257,   284,   284,     0,   284,   350,     0,     0,   254,   387,
     483,   487,   413,     0,   471,   472,   473,     0,     0,     0,
       0,     0,     0,     0,   425,   439,     0,   524,   523,     0,
     540,   564,   558,   559,   560,   561,   562,   565,   567,   144,
     145,   146,   147,   344,   285,   348,     0,   284,   342,   233,
       0,     0,     0,     0,     0,     0,     0,   337,     0,     0,
       0,     0,   474,    16,     0,    16,   417,     0,   433,   431,
     430,     0,     0,   434,   436,   437,   438,   428,     0,   528,
       0,     0,    16,    16,    16,   539,     0,     0,     0,   284,
     284,   352,     0,   347,   346,   284,   284,   284,   353,   241,
       0,     0,     0,    16,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   486,   469,     0,
     475,   423,   424,   422,   421,   432,   435,     0,     0,     0,
       0,     0,    16,     0,     0,     0,     0,   527,     0,     0,
       0,   530,   531,   532,   537,   349,   234,   343,   259,   284,
       0,     0,     0,     0,   476,   445,   459,   441,   444,   442,
       0,   457,     0,   446,   448,   449,   450,   451,   452,   453,
     454,   455,   463,   464,   465,    16,   443,    16,     0,     0,
     484,   522,     0,     0,     0,     0,     0,   515,    16,     0,
       0,     0,   525,   533,   534,   258,     0,     0,     0,     0,
       0,   456,   447,   458,   460,   466,   467,   468,   461,   521,
     517,   514,     0,     0,   516,   518,   519,     0,   355,   356,
     354,     0,     0,   462,   477,   478,   479,   512,   513,   520,
     242,     0,   480,   481
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   449,    69,   450,   537,   783,   784,   771,
     981,   557,    70,   340,   140,   343,   617,   618,    71,   147,
     148,    72,    16,    17,    18,   107,    73,   287,    74,   293,
     288,    75,   355,    76,   357,   645,    77,    78,   185,   208,
     456,   442,    79,   702,   948,   838,   703,   704,    80,    81,
     451,   209,   298,   566,   567,   307,   574,   575,   271,   755,
     272,   273,   768,    19,    20,    21,    22,   318,    23,    24,
      25,   316,   592,    26,    27,    28,    29,    30,    31,    32,
      33,    34,   132,   334,    35,    36,    37,    38,    39,    40,
      41,    42,    43,   104,   311,    82,   356,    83,   635,   636,
     637,   817,   706,   707,   457,   648,   639,    84,   360,   925,
     926,  1088,   176,   387,   388,   389,   177,   391,   392,  1090,
     366,   178,   367,   375,   179,   180,   181,   928,   182,   421,
     656,   929,  1001,  1002,   657,   658,   930,    85,    86,    87,
      88,   248,   249,   250,   747,   876,   967,   968,  1057,  1107,
     877,  1021,  1066,   878,  1159,  1018,  1054,  1055,  1056,  1240,
    1264,  1265,  1266,   960,  1100,  1051,   961,   796,    44,    45,
      46,    47,    48,    49,    50,    51,    89,    90,    91,   883,
     751,    92,   971,  1178,  1119,  1118,  1068,   972,   974,  1126,
    1070,  1069,  1024,   975,    93,    94,   525,  1077,  1028,   977,
     885,   517,   518,    95,    96,   279,   776,   777,   280,    52,
      97,    53,    98,    99,   100,   422
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -955
static const yytype_int16 yypact[] =
{
     144,  1537,   236,    29,   272,   263,   155,   428,   272,   242,
     467,   525,   515,   272,   272,   272,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,   265,   382,     0,   416,
     281,   183,  -955,   285,   219,   137,   304,   690,  -955,  -955,
    -955,  -955,  -955,   309,   309,  -955,  -955,  -955,   787,  -955,
     309,   519,  -955,  -955,  -955,   309,  1493,   309,  1340,   309,
    1474,   309,    21,   309,  1550,   309,   829,  -955,  -955,  1662,
    1684,  -955,  -955,  -955,    87,  -955,   326,   351,  -955,   272,
     272,   355,   132,  -955,   415,   121,   399,   432,  -955,   371,
     171,   371,   440,   455,   501,   503,   505,   516,   543,  -955,
    -955,  -955,   544,   566,   573,   578,   570,  -955,   531,  -955,
      11,    87,    61,  -955,  -955,  -955,  -955,   273,   277,  -955,
     648,  -955,  -955,   284,   132,  -955,    27,  -955,  -955,  -955,
     575,   290,  -955,   464,   473,    -2,   690,  -955,  -955,  -955,
     298,   348,   357,   360,   690,   115,  -955,  -955,  -955,  -955,
    -955,  1324,  -955,  1913,  -955,   367,   373,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,   376,    87,   652,   628,
      61,   151,  -955,   365,   365,   698,   132,  -955,   402,   406,
     420,   -57,   724,   151,   534,   574,    -7,   662,    80,   246,
     710,   604,   722,    38,   613,   609,   181,   600,   605,   212,
     590,   615,   151,   622,   623,   617,     6,   -26,   651,  -955,
     526,   530,   648,   151,    61,   151,  -955,  -955,   527,   536,
    -955,   539,   778,   210,  -955,   533,   540,  -955,   546,  -955,
     828,    61,   548,   -17,    61,    61,   806,   808,   -69,  -955,
     554,   555,  -955,   558,   559,   246,   619,  -955,   556,   468,
     564,   815,   151,   822,   151,   820,  -955,   571,   572,   577,
     825,   871,  -955,   580,   583,  -955,  -955,   741,   888,   889,
    -955,   892,   895,  -955,  -955,  -955,     2,   898,  -955,  -955,
     512,   902,  -955,   905,  -955,  -955,  1747,  -955,   906,   371,
     371,   371,   397,   451,   907,   909,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,   911,  -955,  -955,  -955,    60,   896,
    -955,  -955,  1092,   602,  -955,  -955,  -955,   690,  -955,    61,
     545,  -955,  -955,  -955,  -955,   606,  1549,   122,  -955,   607,
     611,    27,  -955,    27,   690,    27,    27,   915,  -955,   908,
     624,   904,   910,    -2,    -2,   913,   912,   690,   690,   690,
     690,   152,  -955,  -955,   641,  -955,  -955,   914,  -955,   -14,
       5,  -955,   226,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,   690,   690,   690,   690,   690,   690,   690,
     690,   690,   690,   690,   690,   690,   664,  -955,  -955,  -955,
    -955,  -955,  -955,   648,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  1691,  -955,   690,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,   873,   875,   616,   625,    61,   899,
     731,   151,   246,  -955,  -955,    61,   774,   776,    61,   891,
      61,  -955,   637,   893,   775,    61,    61,   151,   901,   643,
     887,   649,   151,   650,   151,   266,   151,   652,   151,   659,
     660,   151,  -955,  -955,  -955,  -955,  -955,   754,  -955,  -955,
    -955,   950,   665,   666,  -955,  -955,  -955,  -955,   667,  -955,
     676,   916,  -955,  -955,  -955,   677,   679,   680,    61,    61,
     684,   691,   692,  -955,  -955,   199,  -955,    16,  -955,   151,
    -955,  -955,   612,  -955,  -955,   827,  -955,    61,  -955,    61,
    -955,   151,  -955,  -955,  -955,    61,  -955,   246,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,   305,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,   390,  -955,  -955,  1009,  -955,  -955,
    -955,  -955,  1006,  1008,  -955,  1691,  -955,  -955,  -955,   246,
    -955,  -955,  1010,  -955,  -955,  1020,  1020,  1020,   371,  1020,
     371,  1020,  -955,  -955,  -955,   723,   726,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,   392,  -955,  -955,
    1120,  1022,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,    46,   735,   734,  -955,  -955,
    -955,  -955,   246,    61,  -955,  -955,  -955,  1660,  1549,  -955,
    -955,  1145,  -955,  -955,  -955,  -955,   372,  -955,   739,  -955,
    -955,  -955,  -955,  -955,  1170,   401,   453,   489,  -955,   690,
     736,  -221,   740,   690,   742,  1025,   125,  -955,  -955,  -955,
    1048,  1049,  -955,  1941,  1941,  1941,  1966,  1966,  1941,  1941,
    1941,  1941,   581,   581,   912,   912,  -955,   750,  -955,  -955,
    -955,  -955,  1041,  -955,   747,  -955,  -955,  -955,  1913,    61,
      61,  -955,  -955,   752,   151,   151,   753,   758,   761,    61,
      61,   767,    61,   769,  -955,    61,   784,   791,   792,   795,
      61,  -955,   648,  -955,   796,  -955,   797,   807,   833,   840,
     841,   842,   843,  -955,  -955,   844,    61,    28,   845,  -955,
    -955,  1703,  -212,  -955,  -955,   751,   846,  -955,  -955,  -955,
     847,   848,  -955,  -955,  -955,    61,    34,   386,   771,    61,
     246,  -955,   857,  -955,  -955,   246,   824,   827,  -955,  -955,
    -955,  -955,    16,  -955,  -955,  -955,   741,  -955,     2,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  1122,  1172,  1179,  1020,
    1180,  1020,  1181,  -955,  -955,  -955,  1092,  -955,  -955,  -955,
    -955,  1549,   487,  -955,  -955,  -955,  -955,   454,  -955,  -955,
     690,  -955,  -955,   690,   690,   690,  1195,    41,   250,   179,
     203,  -955,  -955,   864,   575,  -955,   690,  -955,   672,  -955,
     869,   866,  -955,   872,   882,  -955,  -955,  -955,   883,   890,
    -955,   894,  -955,   897,  -955,  -955,  -955,  -955,   917,   918,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,   180,   919,   834,   246,  -955,   920,  -955,   921,  -955,
    -955,   246,  -955,   922,  -955,  -955,  -955,   916,  -955,  -955,
     932,  1169,  1169,  1169,  1169,  -955,  -955,  -955,  -955,  -955,
      61,   824,  -955,  -955,  -955,  -955,  -955,  1187,  -955,  1205,
    -955,  -955,  -955,    36,  -955,  1188,  -955,  -955,   900,   690,
    -955,  -955,  -955,   690,   690,   930,    20,  1324,   940,   712,
    -955,  -955,  1549,  -955,  1220,  1245,  1275,  -955,   942,   943,
     903,   944,    -4,  -955,  1196,  1300,   246,  -955,  -955,  -955,
    -955,    61,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,    61,  -955,  -955,   648,  -955,  -955,   945,  -955,
    -955,  -955,  -955,  -955,   946,  -955,  -955,  -129,  -955,   199,
    -955,   957,   958,   960,   961,  -955,  -955,  -955,   690,   624,
     690,  -955,   725,  1883,   517,  -955,  -955,  1191,    51,  -955,
    1913,   941,   963,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    1182,  1194,   967,  -955,  -955,   971,   172,  -955,    30,  -955,
    -955,   528,   234,  -955,  -955,    61,   260,  -955,   972,  -955,
     199,   199,   199,   199,   790,   947,   964,  1274,  -955,  1294,
    -955,   690,   690,   663,   712,  -955,    61,  1201,  -955,  -955,
    -955,  -955,  -955,   -66,  -955,  -955,  -955,   -54,    61,    61,
      61,  1042,   150,   -10,  -955,  -955,   973,  -955,  -955,   383,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,   975,   487,  1087,  -955,
      70,  1023,  1095,   977,   978,   979,   987,  -955,   989,   980,
    1627,   996,  -955,   151,    61,   151,  -955,   997,  -955,  -955,
    -955,    61,    61,  -955,  -955,  -955,  -955,  -955,  1177,  -955,
     969,  1026,   151,   151,   151,  -955,   998,  1000,   999,  1294,
      99,  -955,  1002,  -955,  -955,   690,   690,   690,  -955,  -955,
      61,  1011,    61,   151,    61,    61,    61,  1146,    61,   187,
     772,    54,  1093,    61,  1080,  1081,  1076,  -955,  -955,  1037,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,   246,  1063,  1077,
    -152,  1083,   151,  1082,  1303,  1091,  1183,  -955,  1052,    61,
      61,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,    99,
    1325,  1350,  1375,  1067,  -955,  -955,  -955,  -955,  -955,  -955,
      61,  -955,    61,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,   151,  -955,   151,     4,    61,
    -955,  -955,    61,    61,    61,  1089,  1108,  -955,   151,    61,
      61,  1184,  -955,  -955,  -955,  -955,  1073,  1074,  1088,    61,
       3,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,    61,    61,  -955,  -955,  -955,    61,  -955,  -955,
    -955,  1078,   -20,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  1094,  -955,  -955
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -955,  -955,  -955,  -142,  -955,  -192,  -205,  -274,  -573,  -955,
    -211,  -955,  -955,  -955,  -955,  -955,  -955,   598,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  1309,  -955,  -955,  -955,  -955,
    -955,  -955,  -240,  -955,  -955,  -955,  -955,  -955,  1005,   -71,
    1212,   923,  -955,  -955,  -955,  -955,   582,  -512,  -955,  -955,
    -955,  -955,   -50,  -955,   633,   185,  -955,   621,  -954,   535,
    -513,  -955,  -458,  -955,  -955,  -955,  -955,  -111,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,   442,  1121,  -955,  -955,  -955,  -955,  -601,
     629,  -955,  1079,   849,  1114,  -955,   785,  -955,  -955,  -832,
    -955,   303,  -169,   618,  -669,  -955,  -172,   762,  -955,  -955,
    -955,  -955,   335,   404,  -955,  -955,  -801,  -955,  -113,   520,
     -63,  -955,  -955,   395,   626,   461,  -902,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,   158,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,   275,  -955,  -955,  -955,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -955,   674,  -955,  -955,  -955,
    -955,  -955,  -955,  -955,  -955,  -856
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -511
static const yytype_int16 yytable[] =
{
     348,   538,   504,   390,   183,   752,   386,   832,   756,   324,
     325,   927,   373,   476,   477,   240,   793,   247,   345,   255,
    1262,   467,   346,   270,   996,   278,  -230,  1010,   289,   294,
     678,   679,    55,   385,  -230,  -230,  -230,  -230,   913,  1224,
     493,   361,   591,   368,   769,   362,   816,   473,   474,   499,
     341,   505,   345,   507,   363,   345,   346,   988,   444,   346,
    1025,    56,  1103,   522,   809,   914,    57,  1065,   938,    58,
    1114,   998,  1042,   497,   345,   345,  1130,   605,   346,   346,
      59,   482,  1043,   572,   345,   382,   383,   831,   346,   141,
     548,   344,   550,   915,   370,   142,    60,   473,   474,    61,
      -8,    62,   506,   376,   870,  -229,   530,   884,    63,   839,
     470,   381,   573,  -229,  -229,  -229,  -229,   913,   891,   520,
     892,   295,   526,   527,   312,   927,   296,    64,  1225,   345,
     382,   383,   160,   346,  1212,   464,   465,  1089,    65,   345,
     382,   383,   831,   346,   914,  1026,  1158,   440,     1,   916,
     917,   918,   919,   920,   921,   922,   153,    66,   108,   423,
     424,   425,   426,   427,   345,   345,   304,   923,   346,   346,
     924,   305,   915,   428,   429,   430,   431,   432,   433,   434,
     435,  1086,  1104,   436,   445,   446,   447,   448,   810,   317,
    1037,  1027,  1101,   345,   345,   498,   606,   346,   346,   500,
     471,   345,    67,   701,  1105,   346,   941,   621,   595,   596,
     597,   599,   601,   445,   446,   447,   448,   345,   382,   383,
     831,   346,   640,   641,   642,   643,   154,  1089,   916,   917,
     918,   919,   920,   921,   922,  1271,    54,   313,   927,   531,
     532,  1115,   674,  1112,  1116,   113,   923,   319,   368,   924,
     368,  1102,   368,   368,   150,  1128,   475,   423,   424,   425,
     426,   427,   871,   473,   474,   947,  1106,   717,  1245,  1246,
     765,   428,   429,   430,   431,   432,   433,   434,   435,   716,
    1202,   436,   105,   136,   620,   872,   927,   873,   523,   524,
     101,   102,   349,   320,   874,   729,   766,  1272,  1188,   149,
     734,   651,   736,   151,   740,  1213,   742,   676,  1214,   745,
     677,   103,  1011,   106,   664,   665,   666,   667,   152,   347,
     374,   620,   155,  1263,   680,   350,   713,   184,   927,   927,
     342,  1003,   767,   718,   770,  -230,   721,   774,   723,   359,
    -230,   257,   364,   727,   728,   105,    68,   772,   875,   365,
    1052,   989,   782,   347,   300,   481,   347,  1235,   303,   780,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,  1014,   756,   347,   347,   485,   486,   423,
     424,   425,   426,   427,   782,   384,   760,   761,   927,   317,
    1131,   460,   708,   428,   429,   430,   431,   432,   433,   434,
     435,   137,   314,   436,   452,   778,   297,   779,   423,   424,
     425,   426,   427,   781,  -229,   317,   962,   489,   490,  -229,
     138,  1132,   428,   429,   430,   431,   432,   433,   434,   435,
     384,   139,   436,   308,   309,   315,   598,   813,   321,   644,
     384,   322,   323,   326,   453,   454,   101,   102,  1016,   111,
     112,   306,   737,   143,   310,   133,   134,   135,   327,  1022,
     423,   424,   425,   426,   427,   347,   347,   103,   668,   317,
     893,   144,   894,   669,   428,   429,   430,   431,   432,   433,
     434,   435,   738,   739,   436,   512,   513,   799,   145,   801,
     600,  1050,   859,   839,   347,   347,   423,   424,   425,   426,
     427,   814,   347,  1072,   328,   913,   329,   386,   330,   390,
     428,   429,   430,   431,   432,   433,   434,   435,   347,   331,
     436,  1029,   843,   844,   423,   424,   425,   426,   427,   129,
     308,   309,   914,   146,   385,   109,   110,   455,   428,   429,
     430,   431,   432,   433,   434,   435,   332,   681,   436,   130,
     682,   301,   302,  1067,   131,   839,   114,   115,   333,   197,
     915,  1073,  1074,  1075,  1076,   897,   940,   840,   841,   335,
     899,   669,  1079,  1080,  1081,  1082,   336,   848,   849,   116,
     851,   337,   117,   853,   118,   119,   198,   339,   858,   199,
     122,   338,   200,   201,   351,   202,   203,   204,   622,   623,
     966,   358,   541,   369,   869,   370,   826,   973,   434,   435,
     828,   260,   436,   377,   123,   124,   916,   917,   918,   919,
     920,   921,   922,   890,   205,   785,   786,   896,   206,   473,
     474,   773,   262,   782,   923,   371,   156,   924,   157,   158,
     159,   160,   161,   162,   372,   125,   126,   127,   128,   163,
     164,   542,   165,   156,   166,   670,   158,   159,   160,   671,
     162,   386,   352,   378,   353,   354,   163,   164,   672,   165,
     441,   166,   379,  1120,  1121,   380,  1122,  1123,  1124,   963,
     882,   982,   983,   984,   543,   939,   437,   942,   385,   473,
     474,   946,   438,   820,   120,   439,   649,   167,   650,   443,
     652,   653,   156,  1125,   157,   158,   159,   160,   161,   162,
     787,   788,   805,   806,   167,   163,   164,   459,   165,   461,
     166,  1058,   823,   462,   156,  1019,   157,   158,   159,   160,
     161,   162,   423,   424,   425,   426,   427,   163,   164,   463,
     165,   782,   166,   466,  1053,   468,   428,   429,   430,   431,
     432,   433,   434,   435,   797,   798,   436,   800,   985,   802,
     934,   935,   936,   167,   472,  1059,  1060,  1061,   469,  1062,
     931,   932,   478,   945,   824,   168,   169,   661,   662,   121,
    1063,   544,   545,   479,   480,   167,   170,   171,   172,   487,
     483,   173,   168,   169,   484,   491,   488,   423,   424,   425,
     426,   427,   696,   170,   171,   172,   560,  -229,   173,  1015,
     825,   428,   429,   430,   431,   432,   433,   434,   435,   697,
    1017,   436,   561,   562,   492,   698,  1093,  1094,   563,   564,
    1095,   565,   699,   700,  1096,   494,  1040,   496,   495,   207,
     501,   168,   169,   502,   508,   511,   187,   519,  1064,   503,
     514,   188,   170,   171,   172,   509,   992,   173,   510,   515,
     993,   994,   189,   168,   169,   516,  1000,   521,   528,   197,
     529,   533,   534,   540,   170,   171,   172,   535,   536,   173,
     539,   546,   547,  1071,   549,   551,   190,   555,   552,   553,
     556,   568,   569,   973,   554,   570,   198,   558,   571,   199,
     559,   576,   200,   201,  1098,   578,   203,   204,   579,   594,
     602,  1161,   603,  1163,   604,   607,  1108,  1109,  1110,   619,
    1113,   386,   655,   624,   646,  1034,   647,  1036,   654,   659,
    1181,  1182,  1183,   711,   205,   709,   660,   710,   206,   174,
    -340,   663,   712,   436,   714,   675,   275,   175,   385,   715,
     719,  1196,   720,   722,   724,   725,   673,   907,   732,   909,
     731,   726,  1162,   730,   175,   746,   733,   735,   748,  1165,
    1166,   423,   424,   425,   426,   427,   743,   744,  1091,  1092,
    1227,  1000,   749,   750,   753,   428,   429,   430,   431,   432,
     433,   434,   435,   754,   757,   436,   758,   759,  1193,   260,
    1195,   762,  1197,  1198,  1199,   174,  1201,  1203,   763,   764,
     775,  1216,   789,   175,   191,  1204,  1205,  1206,  1207,  1208,
    1209,  1210,  1211,  1243,   790,  1244,   791,   174,   794,  -335,
     423,   424,   425,   426,   427,   175,  1254,  1233,  1234,   795,
     803,   808,  1038,   804,   428,   429,   430,   431,   432,   433,
     434,   435,   811,   812,   436,   821,   830,    -6,  1241,   192,
    1242,   827,   833,   829,   193,   836,   834,   837,   839,   842,
     845,   886,  1190,  1191,  1192,   846,  1247,  1248,   847,   186,
    1249,  1250,  1251,   194,   850,   196,   852,  1255,  1256,   276,
     210,   895,   241,   900,   251,   965,   256,  1261,   258,   195,
     274,   854,   423,   424,   425,   426,   427,  1083,   855,   856,
    1267,  1268,   857,   860,   861,  1269,   428,   429,   430,   431,
     432,   433,   434,   435,   862,   904,   436,   423,   424,   425,
     426,   427,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   428,   429,   430,   431,   432,   433,   434,   435,   277,
     863,   436,   423,   424,   425,   426,   427,   864,   865,   866,
     867,   868,   879,   887,   888,   889,   428,   429,   430,   431,
     432,   433,   434,   435,   898,   905,   436,   423,   424,   425,
     426,   427,   906,   908,   910,   944,   950,   951,   980,   952,
     986,   428,   429,   430,   431,   432,   433,   434,   435,   953,
     954,   436,   423,   424,   425,   426,   427,   955,   987,   990,
    1012,   956,  1041,  1046,   957,   991,   428,   429,   430,   431,
     432,   433,   434,   435,    -7,  1047,   436,   423,   424,   425,
     426,   427,  1099,  1111,   958,   959,  1129,   969,   964,   976,
     970,   428,   429,   430,   431,   432,   433,   434,   435,   979,
     995,   436,   423,   424,   425,   426,   427,   999,  1007,  1008,
    1009,  1179,  1044,  1084,  1020,  1023,   428,   429,   430,   431,
     432,   433,   434,   435,  1030,  1031,   436,  1032,  1033,   393,
    1045,  1085,   423,   424,   425,   426,   427,  1048,  1049,  1078,
    1117,  1127,  1135,  1136,  1137,  1140,   428,   429,   430,   431,
     432,   433,   434,   435,  1138,  1139,   436,   423,   424,   425,
     426,   427,   913,  1160,  1164,  1184,  1167,  1185,  1180,  1186,
    1189,   428,   429,   430,   431,   432,   433,   434,   435,   393,
    1194,   436,   423,   424,   425,   426,   427,  1200,  1215,   914,
    1133,  1217,   394,   395,  1218,  1219,   428,   429,   430,   431,
     432,   433,   434,   435,  1220,  1222,   436,   423,   424,   425,
     426,   427,  1223,  1226,  1168,  1229,  1228,   915,  1231,  1232,
    1252,   428,   429,   430,   431,   432,   433,   434,   435,  1230,
     197,   436,   423,   424,   425,   426,   427,   397,  1239,  1253,
    1258,  1259,   394,   395,  1270,  1257,   428,   429,   430,   431,
     432,   433,   434,   435,   911,  1260,   436,   198,   396,   903,
     199,  1273,  1134,   200,   201,   299,   458,   203,   204,   902,
     741,   949,   978,   916,   917,   918,   919,   920,   921,   922,
     593,   577,  1187,   818,   792,   638,   807,   397,  1169,  1097,
     912,   923,  1221,   835,   924,   205,   933,   997,   943,   206,
    1035,   901,     0,     0,     0,  1170,  1171,     0,     0,  1172,
    1173,   819,     0,  1174,  1175,     0,  1176,     0,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   398,   399,     0,
     400,   401,   402,   403,   404,     0,   822,     0,     0,     0,
       0,     0,     0,     0,     0,   413,   414,  1177,     0,     0,
       0,     0,     0,   415,   416,   417,   418,     0,     0,     0,
       0,   937,     0,     0,   197,     0,     0,     0,     0,   405,
     406,   407,   408,   409,   410,   411,   412,     0,     0,     0,
       0,     0,     0,   197,     0,     0,  1004,     0,   211,     0,
       0,   198,     0,     0,   199,   413,   414,   200,   201,     0,
       0,   203,   204,   415,   416,   417,   418,     0,     0,     0,
     198,  1005,     0,   199,     0,     0,   200,   201,   242,     0,
     203,   204,     0,   243,     0,   244,   212,     4,   213,   205,
       0,     0,     0,   206,   419,   420,     0,     0,     0,     0,
     197,  1006,     0,     0,     5,     6,     0,     0,   205,     0,
       0,     0,   206,     0,     0,     0,     0,     0,   245,     0,
     214,     0,     0,  1087,     0,     0,  1013,   198,   215,   216,
     199,     0,     0,   200,   201,     0,   259,   203,   204,     0,
       0,     0,     0,   260,   419,   420,     0,     0,     0,     0,
       0,  1236,     0,     7,     0,     0,     8,     0,     9,     0,
     217,    10,     0,   261,   262,   205,    11,     0,     0,   206,
     246,    12,    13,    14,    15,     0,  1237,   218,   219,     0,
     220,   221,     0,   222,   223,   224,     0,   225,     0,     0,
     226,   227,     0,   228,     0,   625,   626,   627,   628,   629,
     630,  1238,   631,   632,   633,   634,   229,   230,     0,     0,
       0,   231,   197,   232,     0,   233,     0,   234,     0,   705,
     260,     0,   235,     0,     0,     0,   236,   237,     0,   238,
       0,   281,   282,   283,   197,   284,   285,     0,     0,   198,
       0,   262,   199,     0,     0,   200,   201,     0,     0,   203,
     204,     0,     0,   197,     0,   290,     0,   252,   253,  1141,
     580,   198,     0,     0,   199,     0,     0,   200,   201,     0,
       0,   203,   204,     0,   473,   474,     0,   205,     0,     0,
     198,   206,     0,   199,     0,   291,   200,   201,     0,   880,
     203,   204,     0,     0,     0,     0,   581,     0,     0,   205,
       0,     0,     0,   206,   254,     0,   625,   626,   627,   628,
     629,   630,   263,   631,   632,   633,   634,     0,   205,     0,
       0,     0,   206,   239,   582,     0,     0,     0,     0,   583,
    1142,     0,     0,     0,     0,   584,   585,   625,   626,   627,
     628,   629,   630,     0,   631,   632,   633,   634,   586,   587,
     588,   589,   881,   590,     0,     0,     0,   264,   265,   266,
     267,     0,     0,     0,     0,     0,     0,   268,     0,     0,
       0,  1143,     0,  1144,  1145,  1146,  1147,  1148,  1149,  1150,
     269,     0,     0,     0,     0,     0,     0,     0,     0,  1151,
    1152,     0,     0,  1153,     0,     0,     0,  1154,     0,  1155,
     423,   424,   425,   426,   427,  1156,     0,     0,     0,     0,
       0,     0,     0,     0,   428,   429,   430,   431,   432,   433,
     434,   435,     0,     0,   436,     0,     0,     0,     0,   455,
     423,   424,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   428,   429,   430,   431,   432,   433,
     434,   435,     0,     0,   436,     0,     0,  1157,  -511,  -511,
    -511,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -511,  -511,  -511,  -511,   432,   433,   434,   435,
       0,     0,   436,   423,   424,   425,   815,     0,     0,     0,
       0,     0,   286,     0,     0,     0,     0,   428,   429,   430,
     431,   432,   433,   434,   435,     0,     0,   436,     0,     0,
       0,     0,     0,     0,   292,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -510,     0,     0,     0,     0,     0,     0,
       0,  1039
};

static const yytype_int16 yycheck[] =
{
     142,   275,   242,   175,    67,   517,   175,   676,   521,   120,
     121,   812,    14,   218,   219,    86,   589,    88,    14,    90,
      17,   213,    18,    94,   926,    96,     6,    31,    99,   100,
      25,    26,     3,   175,    14,    15,    16,    17,    18,   191,
     232,    14,   316,   156,    28,    18,   647,    17,    18,    75,
      39,   243,    14,   245,    27,    14,    18,    21,   200,    18,
     189,    32,   116,    80,    18,    45,    37,  1021,    27,    40,
      80,   927,    21,    67,    14,    14,     6,    17,    18,    18,
      51,   223,    31,    81,    14,    15,    16,    17,    18,    89,
     282,   141,   284,    73,   315,    95,    67,    17,    18,    70,
     321,    72,   244,   166,    76,     6,   175,   319,    79,   321,
     117,   174,   110,    14,    15,    16,    17,    18,    84,   261,
      86,    34,   264,   265,     3,   926,    39,    98,   280,    14,
      15,    16,    17,    18,    80,   192,   193,  1039,   109,    14,
      15,    16,    17,    18,    45,   274,  1100,   197,     4,   129,
     130,   131,   132,   133,   134,   135,    19,   128,     3,     7,
       8,     9,    10,    11,    14,    14,    34,   147,    18,    18,
     150,    39,    73,    21,    22,    23,    24,    25,    26,    27,
      28,  1037,   236,    31,    33,    34,    35,    36,   142,    18,
     991,   320,   258,    14,    14,   189,   338,    18,    18,   225,
     207,    14,   173,   443,   258,    18,    27,   349,   319,   320,
     321,   322,   323,    33,    34,    35,    36,    14,    15,    16,
      17,    18,   100,   101,   102,   103,    89,  1129,   129,   130,
     131,   132,   133,   134,   135,   255,     0,   116,  1039,   308,
     309,   251,   384,    93,   254,     3,   147,    76,   361,   150,
     363,   317,   365,   366,    71,  1087,   176,     7,     8,     9,
      10,    11,   234,    17,    18,   838,   320,   472,   264,   265,
      71,    21,    22,    23,    24,    25,    26,    27,    28,   471,
      93,    31,    19,    18,   347,   257,  1087,   259,   305,   306,
      18,    19,    19,   122,   266,   487,    97,   317,  1130,    18,
     492,   364,   494,    18,   496,   251,   498,   321,   254,   501,
     324,    39,   316,    50,   377,   378,   379,   380,    99,   315,
     322,   384,    18,   320,   319,    52,   468,    18,  1129,  1130,
     319,   932,   133,   475,   318,   315,   478,   542,   480,   154,
     320,   320,   315,   485,   486,    19,   317,   539,   320,   322,
     320,   315,   557,   315,     3,   317,   315,  1189,     3,   551,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   946,   887,   315,   315,   196,   197,     7,
       8,     9,    10,    11,   589,   315,   528,   529,  1189,    18,
     320,   206,   455,    21,    22,    23,    24,    25,    26,    27,
      28,    19,     3,    31,    39,   547,   319,   549,     7,     8,
       9,    10,    11,   555,   315,    18,   236,   205,   206,   320,
      38,  1090,    21,    22,    23,    24,    25,    26,    27,    28,
     315,    49,    31,    18,    19,     3,    39,   642,   267,   317,
     315,   270,   271,     3,    79,    80,    18,    19,   960,     7,
       8,   319,   186,    37,    39,    13,    14,    15,     3,   971,
       7,     8,     9,    10,    11,   315,   315,    39,   316,    18,
      84,    55,    86,   321,    21,    22,    23,    24,    25,    26,
      27,    28,   216,   217,    31,   275,   276,   598,    72,   600,
      39,   319,   732,   321,   315,   315,     7,     8,     9,    10,
      11,   643,   315,   243,     3,    18,     3,   676,     3,   681,
      21,    22,    23,    24,    25,    26,    27,    28,   315,     3,
      31,   979,   714,   715,     7,     8,     9,    10,    11,    14,
      18,    19,    45,   117,   676,   107,   108,   172,    21,    22,
      23,    24,    25,    26,    27,    28,     3,   321,    31,    34,
     324,   109,   110,   319,    39,   321,    89,    90,    14,    40,
      73,   301,   302,   303,   304,   770,   316,   709,   710,     3,
     775,   321,  1030,  1031,  1032,  1033,     3,   719,   720,   112,
     722,     3,   115,   725,   117,   118,    67,    56,   730,    70,
      65,    21,    73,    74,   317,    76,    77,    78,    53,    54,
     874,   317,   134,    28,   746,   315,   669,   881,    27,    28,
     673,    83,    31,   315,    89,    90,   129,   130,   131,   132,
     133,   134,   135,   765,   105,   320,   321,   769,   109,    17,
      18,    19,   104,   838,   147,   171,    12,   150,    14,    15,
      16,    17,    18,    19,   171,   120,   121,   122,   123,    25,
      26,   183,    28,    12,    30,    14,    15,    16,    17,    18,
      19,   830,    14,   315,    16,    17,    25,    26,    27,    28,
      18,    30,   315,   290,   291,   315,   293,   294,   295,   871,
     751,   892,   893,   894,   216,   827,   319,   829,   830,    17,
      18,    19,   319,   321,   227,   319,   361,    73,   363,    71,
     365,   366,    12,   320,    14,    15,    16,    17,    18,    19,
     320,   321,   320,   321,    73,    25,    26,    19,    28,   317,
      30,   193,   321,   317,    12,   965,    14,    15,    16,    17,
      18,    19,     7,     8,     9,    10,    11,    25,    26,   319,
      28,   946,    30,    19,  1018,   211,    21,    22,    23,    24,
      25,    26,    27,    28,   596,   597,    31,   599,   900,   601,
     823,   824,   825,    73,   102,   237,   238,   239,   194,   241,
     316,   317,    62,   836,   321,   151,   152,   373,   374,   312,
     252,   313,   314,   179,    62,    73,   162,   163,   164,   189,
     177,   167,   151,   152,   185,   205,   191,     7,     8,     9,
      10,    11,   138,   162,   163,   164,    65,   320,   167,   951,
     321,    21,    22,    23,    24,    25,    26,    27,    28,   155,
     962,    31,    81,    82,   209,   161,   163,   164,    87,    88,
     167,    90,   168,   169,   171,   213,   319,   220,   215,   320,
     189,   151,   152,   317,   317,    67,    59,    19,   320,   319,
     317,    64,   162,   163,   164,   319,   919,   167,   319,   319,
     923,   924,    75,   151,   152,   319,   929,   319,    62,    40,
      62,   317,   317,   317,   162,   163,   164,   319,   319,   167,
     261,   317,    67,  1025,    62,    65,    99,    62,   317,   317,
      19,     3,     3,  1167,   317,     3,    67,   317,     3,    70,
     317,     3,    73,    74,  1046,     3,    77,    78,     3,     3,
       3,  1103,     3,  1105,     3,    19,  1058,  1059,  1060,   317,
    1062,  1090,    14,   317,   317,   988,   315,   990,    13,    25,
    1122,  1123,  1124,   317,   105,    62,    26,    62,   109,   315,
     316,    28,   317,    31,    45,    31,   117,   323,  1090,   218,
     176,  1143,   176,    62,   317,    62,   315,   799,    71,   801,
     317,   186,  1104,    62,   323,   211,   317,   317,    18,  1111,
    1112,     7,     8,     9,    10,    11,   317,   317,  1041,  1042,
    1172,  1044,   317,   317,   317,    21,    22,    23,    24,    25,
      26,    27,    28,   317,   317,    31,   317,   317,  1140,    83,
    1142,   317,  1144,  1145,  1146,   315,  1148,  1149,   317,   317,
     183,  1153,     3,   323,   227,   243,   244,   245,   246,   247,
     248,   249,   250,  1215,    18,  1217,    18,   315,    18,   317,
       7,     8,     9,    10,    11,   323,  1228,  1179,  1180,    19,
     317,    19,   317,   317,    21,    22,    23,    24,    25,    26,
      27,    28,   317,   319,    31,   316,    31,   321,  1200,   272,
    1202,   321,    14,   321,   277,   315,    17,    26,   321,   317,
     317,   320,  1135,  1136,  1137,   317,  1218,  1219,   317,    74,
    1222,  1223,  1224,   296,   317,    80,   317,  1229,  1230,   260,
      85,   320,    87,   269,    89,   261,    91,  1239,    93,   312,
      95,   317,     7,     8,     9,    10,    11,   317,   317,   317,
    1252,  1253,   317,   317,   317,  1257,    21,    22,    23,    24,
      25,    26,    27,    28,   317,     3,    31,     7,     8,     9,
      10,    11,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    21,    22,    23,    24,    25,    26,    27,    28,   320,
     317,    31,     7,     8,     9,    10,    11,   317,   317,   317,
     317,   317,   317,   317,   317,   317,    21,    22,    23,    24,
      25,    26,    27,    28,   317,     3,    31,     7,     8,     9,
      10,    11,     3,     3,     3,   321,   317,   321,    19,   317,
       3,    21,    22,    23,    24,    25,    26,    27,    28,   317,
     317,    31,     7,     8,     9,    10,    11,   317,     3,    21,
      14,   317,    21,    31,   317,   315,    21,    22,    23,    24,
      25,    26,    27,    28,   321,    31,    31,     7,     8,     9,
      10,    11,    31,   191,   317,   317,   149,   317,   319,   317,
     319,    21,    22,    23,    24,    25,    26,    27,    28,   317,
     320,    31,     7,     8,     9,    10,    11,   317,   316,   316,
     316,   292,   321,   316,   319,   319,    21,    22,    23,    24,
      25,    26,    27,    28,   317,   317,    31,   317,   317,     5,
     317,   317,     7,     8,     9,    10,    11,   320,   317,   317,
     317,   316,   315,   315,   315,   315,    21,    22,    23,    24,
      25,    26,    27,    28,   317,   316,    31,     7,     8,     9,
      10,    11,    18,   317,   317,   317,   139,   317,   292,   320,
     318,    21,    22,    23,    24,    25,    26,    27,    28,     5,
     319,    31,     7,     8,     9,    10,    11,   191,   245,    45,
     317,   261,    68,    69,   263,   269,    21,    22,    23,    24,
      25,    26,    27,    28,   317,   292,    31,     7,     8,     9,
      10,    11,   285,   280,   187,    62,   284,    73,   185,   317,
     281,    21,    22,    23,    24,    25,    26,    27,    28,   288,
      40,    31,     7,     8,     9,    10,    11,   113,   321,   281,
     317,   317,    68,    69,   316,   211,    21,    22,    23,    24,
      25,    26,    27,    28,   806,   317,    31,    67,    84,   788,
      70,   317,   317,    73,    74,   106,   204,    77,    78,   786,
     497,   839,   887,   129,   130,   131,   132,   133,   134,   135,
     316,   310,  1129,   648,   585,   356,   316,   113,   261,  1044,
     811,   147,  1167,   681,   150,   105,   820,   927,   830,   109,
     989,   777,    -1,    -1,    -1,   278,   279,    -1,    -1,   282,
     283,   316,    -1,   286,   287,    -1,   289,    -1,    -1,   195,
     196,   197,   198,   199,   200,   201,   202,   153,   154,    -1,
     156,   157,   158,   159,   160,    -1,   316,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,   222,   320,    -1,    -1,
      -1,    -1,    -1,   229,   230,   231,   232,    -1,    -1,    -1,
      -1,   316,    -1,    -1,    40,    -1,    -1,    -1,    -1,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,   316,    -1,    45,    -1,
      -1,    67,    -1,    -1,    70,   221,   222,    73,    74,    -1,
      -1,    77,    78,   229,   230,   231,   232,    -1,    -1,    -1,
      67,   316,    -1,    70,    -1,    -1,    73,    74,   228,    -1,
      77,    78,    -1,   233,    -1,   235,    83,    40,    85,   105,
      -1,    -1,    -1,   109,   310,   311,    -1,    -1,    -1,    -1,
      40,   316,    -1,    -1,    57,    58,    -1,    -1,   105,    -1,
      -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,   268,    -1,
     117,    -1,    -1,   319,    -1,    -1,   316,    67,   125,   126,
      70,    -1,    -1,    73,    74,    -1,    76,    77,    78,    -1,
      -1,    -1,    -1,    83,   310,   311,    -1,    -1,    -1,    -1,
      -1,   316,    -1,   106,    -1,    -1,   109,    -1,   111,    -1,
     157,   114,    -1,   103,   104,   105,   119,    -1,    -1,   109,
     320,   124,   125,   126,   127,    -1,   316,   174,   175,    -1,
     177,   178,    -1,   180,   181,   182,    -1,   184,    -1,    -1,
     187,   188,    -1,   190,    -1,   136,   137,   138,   139,   140,
     141,   316,   143,   144,   145,   146,   203,   204,    -1,    -1,
      -1,   208,    40,   210,    -1,   212,    -1,   214,    -1,    18,
      83,    -1,   219,    -1,    -1,    -1,   223,   224,    -1,   226,
      -1,    59,    60,    61,    40,    63,    64,    -1,    -1,    67,
      -1,   104,    70,    -1,    -1,    73,    74,    -1,    -1,    77,
      78,    -1,    -1,    40,    -1,    61,    -1,   273,   274,   122,
       3,    67,    -1,    -1,    70,    -1,    -1,    73,    74,    -1,
      -1,    77,    78,    -1,    17,    18,    -1,   105,    -1,    -1,
      67,   109,    -1,    70,    -1,    91,    73,    74,    -1,    76,
      77,    78,    -1,    -1,    -1,    -1,    39,    -1,    -1,   105,
      -1,    -1,    -1,   109,   320,    -1,   136,   137,   138,   139,
     140,   141,   252,   143,   144,   145,   146,    -1,   105,    -1,
      -1,    -1,   109,   320,    67,    -1,    -1,    -1,    -1,    72,
     193,    -1,    -1,    -1,    -1,    78,    79,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    91,    92,
      93,    94,   139,    96,    -1,    -1,    -1,   297,   298,   299,
     300,    -1,    -1,    -1,    -1,    -1,    -1,   307,    -1,    -1,
      -1,   234,    -1,   236,   237,   238,   239,   240,   241,   242,
     320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,    -1,   262,
       7,     8,     9,    10,    11,   268,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    -1,    31,    -1,    -1,    -1,    -1,   172,
       7,     8,     9,    10,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    -1,    31,    -1,    -1,   320,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    -1,    31,     7,     8,     9,   316,    -1,    -1,    -1,
      -1,    -1,   320,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    -1,    31,    -1,    -1,
      -1,    -1,    -1,    -1,   320,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   320,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   326,   327,    40,    57,    58,   106,   109,   111,
     114,   119,   124,   125,   126,   127,   347,   348,   349,   388,
     389,   390,   391,   393,   394,   395,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   493,   494,   495,   496,   497,   498,
     499,   500,   534,   536,     0,     3,    32,    37,    40,    51,
      67,    70,    72,    79,    98,   109,   128,   173,   317,   329,
     337,   343,   346,   351,   353,   356,   358,   361,   362,   367,
     373,   374,   420,   422,   432,   462,   463,   464,   465,   501,
     502,   503,   506,   519,   520,   528,   529,   535,   537,   538,
     539,    18,    19,    39,   418,    19,    50,   350,     3,   107,
     108,   418,   418,     3,    89,    90,   112,   115,   117,   118,
     227,   312,    65,    89,    90,   120,   121,   122,   123,    14,
      34,    39,   407,   418,   418,   418,    18,    19,    38,    49,
     339,    89,    95,    37,    55,    72,   117,   344,   345,    18,
      71,    18,    99,    19,    89,    18,    12,    14,    15,    16,
      17,    18,    19,    25,    26,    28,    30,    73,   151,   152,
     162,   163,   164,   167,   315,   323,   437,   441,   446,   449,
     450,   451,   453,   455,    18,   363,   363,    59,    64,    75,
      99,   227,   272,   277,   296,   312,   363,    40,    67,    70,
      73,    74,    76,    77,    78,   105,   109,   320,   364,   376,
     363,    45,    83,    85,   117,   125,   126,   157,   174,   175,
     177,   178,   180,   181,   182,   184,   187,   188,   190,   203,
     204,   208,   210,   212,   214,   219,   223,   224,   226,   320,
     364,   363,   228,   233,   235,   268,   320,   364,   466,   467,
     468,   363,   273,   274,   320,   364,   363,   320,   363,    76,
      83,   103,   104,   252,   297,   298,   299,   300,   307,   320,
     364,   383,   385,   386,   363,   117,   260,   320,   364,   530,
     533,    59,    60,    61,    63,    64,   320,   352,   355,   364,
      61,    91,   320,   354,   364,    34,    39,   319,   377,   350,
       3,   418,   418,     3,    34,    39,   319,   380,    18,    19,
      39,   419,     3,   116,     3,     3,   396,    18,   392,    76,
     122,   267,   270,   271,   392,   392,     3,     3,     3,     3,
       3,     3,     3,    14,   408,     3,     3,     3,    21,    56,
     338,    39,   319,   340,   377,    14,    18,   315,   328,    19,
      52,   317,    14,    16,    17,   357,   421,   359,   317,   380,
     433,    14,    18,    27,   315,   322,   445,   447,   453,    28,
     315,   171,   171,    14,   322,   448,   455,   315,   315,   315,
     315,   455,    15,    16,   315,   328,   437,   438,   439,   440,
     441,   442,   443,     5,    68,    69,    84,   113,   153,   154,
     156,   157,   158,   159,   160,   195,   196,   197,   198,   199,
     200,   201,   202,   221,   222,   229,   230,   231,   232,   310,
     311,   454,   540,     7,     8,     9,    10,    11,    21,    22,
      23,    24,    25,    26,    27,    28,    31,   319,   319,   319,
     377,    18,   366,    71,   328,    33,    34,    35,    36,   328,
     330,   375,    39,    79,    80,   172,   365,   429,   365,    19,
     380,   317,   317,   319,   192,   193,    19,   330,   211,   194,
     117,   207,   102,    17,    18,   176,   331,   331,    62,   179,
      62,   317,   328,   177,   185,   196,   197,   189,   191,   205,
     206,   205,   209,   330,   213,   215,   220,    67,   189,    75,
     225,   189,   317,   319,   357,   330,   328,   330,   317,   319,
     319,    67,   275,   276,   317,   319,   319,   526,   527,    19,
     328,   319,    80,   305,   306,   521,   328,   328,    62,    62,
     175,   308,   309,   317,   317,   319,   319,   331,   332,   261,
     317,   134,   183,   216,   313,   314,   317,    67,   330,    62,
     330,    65,   317,   317,   317,    62,    19,   336,   317,   317,
      65,    81,    82,    87,    88,    90,   378,   379,     3,     3,
       3,     3,    81,   110,   381,   382,     3,   419,     3,     3,
       3,    39,    67,    72,    78,    79,    91,    92,    93,    94,
      96,   332,   397,   429,     3,   392,   392,   392,    39,   392,
      39,   392,     3,     3,     3,    17,   328,    19,    40,    41,
      42,    43,    44,    45,    46,    47,    48,   341,   342,   317,
     455,   328,    53,    54,   317,   136,   137,   138,   139,   140,
     141,   143,   144,   145,   146,   423,   424,   425,   427,   431,
     100,   101,   102,   103,   317,   360,   317,   315,   430,   447,
     447,   455,   447,   447,    13,    14,   455,   459,   460,    25,
      26,   448,   448,    28,   455,   455,   455,   455,   316,   321,
      14,    18,    27,   315,   328,    31,   321,   324,    25,    26,
     319,   321,   324,   455,   455,   455,   455,   455,   455,   455,
     455,   455,   455,   455,   455,   455,   138,   155,   161,   168,
     169,   357,   368,   371,   372,    18,   427,   428,   455,    62,
      62,   317,   317,   328,    45,   218,   330,   331,   328,   176,
     176,   328,    62,   328,   317,    62,   186,   328,   328,   330,
      62,   317,    71,   317,   330,   317,   330,   186,   216,   217,
     330,   366,   330,   317,   317,   330,   211,   469,    18,   317,
     317,   505,   372,   317,   317,   384,   385,   317,   317,   317,
     328,   328,   317,   317,   317,    71,    97,   133,   387,    28,
     318,   334,   330,    19,   331,   183,   531,   532,   328,   328,
     330,   328,   331,   332,   333,   320,   321,   320,   321,     3,
      18,    18,   428,   333,    18,    19,   492,   492,   492,   392,
     492,   392,   492,   317,   317,   320,   321,   316,    19,    18,
     142,   317,   319,   331,   328,   316,   424,   426,   431,   316,
     321,   316,   316,   321,   321,   321,   455,   321,   455,   321,
      31,    17,   439,    14,    17,   442,   315,    26,   370,   321,
     328,   328,   317,   330,   330,   317,   317,   317,   328,   328,
     317,   328,   317,   328,   317,   317,   317,   317,   328,   357,
     317,   317,   317,   317,   317,   317,   317,   317,   317,   328,
      76,   234,   257,   259,   266,   320,   470,   475,   478,   317,
      76,   139,   364,   504,   319,   525,   320,   317,   317,   317,
     328,    84,    86,    84,    86,   320,   328,   331,   317,   331,
     269,   531,   379,   382,     3,     3,     3,   492,     3,   492,
       3,   342,   425,    18,    45,    73,   129,   130,   131,   132,
     133,   134,   135,   147,   150,   434,   435,   451,   452,   456,
     461,   316,   317,   459,   455,   455,   455,   316,    27,   328,
     316,    27,   328,   438,   321,   455,    19,   333,   369,   371,
     317,   321,   317,   317,   317,   317,   317,   317,   317,   317,
     488,   491,   236,   330,   319,   261,   332,   471,   472,   317,
     319,   507,   512,   332,   513,   518,   317,   524,   384,   317,
      19,   335,   335,   335,   335,   328,     3,     3,    21,   315,
      21,   315,   455,   455,   455,   320,   461,   454,   540,   317,
     455,   457,   458,   424,   316,   316,   316,   316,   316,   316,
      31,   316,    14,   316,   333,   328,   372,   328,   480,   357,
     319,   476,   372,   319,   517,   189,   274,   320,   523,   387,
     317,   317,   317,   317,   455,   460,   455,   451,   317,   148,
     319,    21,    21,    31,   321,   317,    31,    31,   320,   317,
     319,   490,   320,   332,   481,   482,   483,   473,   193,   237,
     238,   239,   241,   252,   320,   383,   477,   319,   511,   516,
     515,   328,   243,   301,   302,   303,   304,   522,   317,   387,
     387,   387,   387,   317,   316,   317,   540,   319,   436,   461,
     444,   455,   455,   163,   164,   167,   171,   458,   328,    31,
     489,   258,   317,   116,   236,   258,   320,   474,   328,   328,
     328,   191,    93,   328,    80,   251,   254,   317,   510,   509,
     290,   291,   293,   294,   295,   320,   514,   316,   434,   149,
       6,   320,   439,   317,   317,   315,   315,   315,   317,   316,
     315,   122,   193,   234,   236,   237,   238,   239,   240,   241,
     242,   252,   253,   256,   260,   262,   268,   320,   383,   479,
     317,   330,   328,   330,   317,   328,   328,   139,   187,   261,
     278,   279,   282,   283,   286,   287,   289,   320,   508,   292,
     292,   330,   330,   330,   317,   317,   320,   436,   434,   318,
     455,   455,   455,   328,   319,   328,   330,   328,   328,   328,
     191,   328,    93,   328,   243,   244,   245,   246,   247,   248,
     249,   250,    80,   251,   254,   245,   328,   261,   263,   269,
     317,   518,   292,   285,   191,   280,   280,   330,   284,    62,
     288,   185,   317,   328,   328,   434,   316,   316,   316,   321,
     484,   328,   328,   330,   330,   264,   265,   328,   328,   328,
     328,   328,   281,   281,   330,   328,   328,   211,   317,   317,
     317,   328,    17,   320,   485,   486,   487,   328,   328,   328,
     316,   255,   317,   317
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 400 "cf-parse.y"
    { return 0; ;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 401 "cf-parse.y"
    { return 0; ;}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 414 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 415 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; ;}
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 419 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   ;}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 423 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   ;}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 432 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); ;}
    break;

  case 12:

/* Line 1464 of yacc.c  */
#line 433 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 434 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 14:

/* Line 1464 of yacc.c  */
#line 435 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 436 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 16:

/* Line 1464 of yacc.c  */
#line 437 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 444 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 451 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 459 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; ;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 463 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 467 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   ;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 474 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   ;}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 482 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); ;}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 483 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 489 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  ;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 498 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); ;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 499 "cf-parse.y"
    { (yyval.t) = bird_name; ;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 503 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   ;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 508 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); ;}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 509 "cf-parse.y"
    { (yyval.g) = stderr; ;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 513 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 514 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 518 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); ;}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 519 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); ;}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 523 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; ;}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 524 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; ;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 525 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; ;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 526 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; ;}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 527 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; ;}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 528 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; ;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 529 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; ;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 530 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; ;}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 531 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; ;}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 537 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); ;}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 538 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   ;}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 547 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; ;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 548 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; ;}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 549 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; ;}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 550 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; ;}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 553 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; ;}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 554 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; ;}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 555 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; ;}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 556 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; ;}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 568 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (3)].t), RECONFIG_HARD); ;}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 571 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (4)].t), RECONFIG_SOFT); ;}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 574 "cf-parse.y"
    { cmd_shutdown(); ;}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 577 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 586 "cf-parse.y"
    {
#ifndef CONFIG_MULTIPLE_TABLES
     if (cf_krt)
       cf_error("Kernel protocol already defined");
#endif
     cf_krt = this_proto = proto_config_new(&proto_unix_kernel, sizeof(struct krt_config));
     this_proto->preference = DEF_PREF_INHERITED;
     THIS_KRT->scan_time = 60;
     THIS_KRT->learn = THIS_KRT->persist = 0;
     krt_scan_construct(THIS_KRT);
     krt_set_construct(THIS_KRT);
   ;}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 602 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); ;}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 603 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 607 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   ;}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 614 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); ;}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 620 "cf-parse.y"
    {
     if (cf_kif)
       cf_error("Kernel device protocol already defined");
     cf_kif = this_proto = proto_config_new(&proto_unix_iface, sizeof(struct kif_config));
     this_proto->preference = DEF_PREF_DIRECT;
     THIS_KIF->scan_time = 60;
     init_list(&THIS_KIF->primary);
     krt_if_construct(THIS_KIF);
   ;}
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 633 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 637 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   ;}
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 650 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->scan.table_id = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 663 "cf-parse.y"
    {
   new_config->router_id = (yyvsp[(3) - (4)].i32);
   ;}
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 669 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); ;}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 671 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   ;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 690 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); ;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 691 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); ;}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 692 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; ;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 693 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; ;}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 700 "cf-parse.y"
    {
   rt_new_table((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 712 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = SYM_PROTO;
     s->def = this_proto;
     this_proto->name = s->name;
     ;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 718 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), SYM_PROTO, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   ;}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 726 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 730 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); ;}
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 731 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); ;}
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 732 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); ;}
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 733 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 734 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 735 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); ;}
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 736 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 737 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); ;}
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 741 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); ;}
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 743 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; ;}
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 744 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; ;}
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 748 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 756 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 757 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 765 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   ;}
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 773 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; ;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 774 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; ;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 775 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; ;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 779 "cf-parse.y"
    { this_ipn->positive = 1; ;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 780 "cf-parse.y"
    { this_ipn->positive = 0; ;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 797 "cf-parse.y"
    {
     struct rt_dev_config *p = proto_config_new(&proto_device, sizeof(struct rt_dev_config));
     this_proto = &p->c;
     p->c.preference = DEF_PREF_DIRECT;
     init_list(&p->iface_list);
   ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 812 "cf-parse.y"
    {
     struct rt_dev_config *p = (void *) this_proto;
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&p->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   ;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 827 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 828 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 829 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 834 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 838 "cf-parse.y"
    { (yyval.i) = D_STATES; ;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 839 "cf-parse.y"
    { (yyval.i) = D_ROUTES; ;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 840 "cf-parse.y"
    { (yyval.i) = D_FILTERS; ;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 841 "cf-parse.y"
    { (yyval.i) = D_IFACES; ;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 842 "cf-parse.y"
    { (yyval.i) = D_EVENTS; ;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 843 "cf-parse.y"
    { (yyval.i) = D_PACKETS; ;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 849 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 850 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 851 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 856 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 860 "cf-parse.y"
    { (yyval.i) = MD_STATES; ;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 861 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; ;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 882 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   ;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 900 "cf-parse.y"
    { ;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 901 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 902 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); ;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 903 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 904 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); ;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 905 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); ;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 914 "cf-parse.y"
    { cmd_show_status(); ;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 917 "cf-parse.y"
    { cmd_show_memory(); ;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 920 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); ;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 923 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); ;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 927 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 931 "cf-parse.y"
    { if_show(); ;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 934 "cf-parse.y"
    { if_show_summary(); ;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 937 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); ;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 940 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   ;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 946 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   ;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 952 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   ;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 959 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   ;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 964 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   ;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 969 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   ;}
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 974 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   ;}
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 978 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   ;}
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 982 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 992 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 1000 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   ;}
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 1004 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   ;}
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 1011 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 1012 "cf-parse.y"
    { (yyval.i) = 2; ;}
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 1016 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].s)); ;}
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 1020 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); ;}
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 1022 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); ;}
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 1024 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); ;}
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 1026 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); ;}
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 1028 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); ;}
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 1030 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); ;}
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 1032 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); ;}
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 1034 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
;}
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 1040 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 1041 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 1046 "cf-parse.y"
    { (yyval.i) = 4096; ;}
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 1047 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   ;}
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 1054 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); ;}
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 1056 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); ;}
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 1058 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); ;}
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 1060 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); ;}
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 1062 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); ;}
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 1064 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); ;}
    break;

  case 192:

/* Line 1464 of yacc.c  */
#line 1068 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 193:

/* Line 1464 of yacc.c  */
#line 1072 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 1075 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); ;}
    break;

  case 195:

/* Line 1464 of yacc.c  */
#line 1078 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 196:

/* Line 1464 of yacc.c  */
#line 1079 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 197:

/* Line 1464 of yacc.c  */
#line 1080 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 198:

/* Line 1464 of yacc.c  */
#line 1084 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 1085 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 200:

/* Line 1464 of yacc.c  */
#line 1086 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 201:

/* Line 1464 of yacc.c  */
#line 1094 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); ;}
    break;

  case 202:

/* Line 1464 of yacc.c  */
#line 1095 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   ;}
    break;

  case 203:

/* Line 1464 of yacc.c  */
#line 1104 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); ;}
    break;

  case 204:

/* Line 1464 of yacc.c  */
#line 1108 "cf-parse.y"
    { (yyval.i) = T_INT; ;}
    break;

  case 205:

/* Line 1464 of yacc.c  */
#line 1109 "cf-parse.y"
    { (yyval.i) = T_BOOL; ;}
    break;

  case 206:

/* Line 1464 of yacc.c  */
#line 1110 "cf-parse.y"
    { (yyval.i) = T_IP; ;}
    break;

  case 207:

/* Line 1464 of yacc.c  */
#line 1111 "cf-parse.y"
    { (yyval.i) = T_PREFIX; ;}
    break;

  case 208:

/* Line 1464 of yacc.c  */
#line 1112 "cf-parse.y"
    { (yyval.i) = T_PAIR; ;}
    break;

  case 209:

/* Line 1464 of yacc.c  */
#line 1113 "cf-parse.y"
    { (yyval.i) = T_QUAD; ;}
    break;

  case 210:

/* Line 1464 of yacc.c  */
#line 1114 "cf-parse.y"
    { (yyval.i) = T_STRING; ;}
    break;

  case 211:

/* Line 1464 of yacc.c  */
#line 1115 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; ;}
    break;

  case 212:

/* Line 1464 of yacc.c  */
#line 1116 "cf-parse.y"
    { (yyval.i) = T_PATH; ;}
    break;

  case 213:

/* Line 1464 of yacc.c  */
#line 1117 "cf-parse.y"
    { (yyval.i) = T_CLIST; ;}
    break;

  case 214:

/* Line 1464 of yacc.c  */
#line 1118 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   ;}
    break;

  case 215:

/* Line 1464 of yacc.c  */
#line 1138 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   ;}
    break;

  case 216:

/* Line 1464 of yacc.c  */
#line 1149 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 217:

/* Line 1464 of yacc.c  */
#line 1150 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 218:

/* Line 1464 of yacc.c  */
#line 1157 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 219:

/* Line 1464 of yacc.c  */
#line 1158 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 220:

/* Line 1464 of yacc.c  */
#line 1165 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   ;}
    break;

  case 221:

/* Line 1464 of yacc.c  */
#line 1174 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 223:

/* Line 1464 of yacc.c  */
#line 1182 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  ;}
    break;

  case 224:

/* Line 1464 of yacc.c  */
#line 1206 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); ;}
    break;

  case 225:

/* Line 1464 of yacc.c  */
#line 1207 "cf-parse.y"
    { (yyval.s)=NULL; ;}
    break;

  case 226:

/* Line 1464 of yacc.c  */
#line 1211 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 227:

/* Line 1464 of yacc.c  */
#line 1224 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 228:

/* Line 1464 of yacc.c  */
#line 1227 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   ;}
    break;

  case 229:

/* Line 1464 of yacc.c  */
#line 1240 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 230:

/* Line 1464 of yacc.c  */
#line 1241 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; ;}
    break;

  case 231:

/* Line 1464 of yacc.c  */
#line 1244 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); ;}
    break;

  case 232:

/* Line 1464 of yacc.c  */
#line 1245 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); ;}
    break;

  case 233:

/* Line 1464 of yacc.c  */
#line 1249 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   ;}
    break;

  case 234:

/* Line 1464 of yacc.c  */
#line 1252 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   ;}
    break;

  case 235:

/* Line 1464 of yacc.c  */
#line 1261 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); ;}
    break;

  case 236:

/* Line 1464 of yacc.c  */
#line 1265 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 237:

/* Line 1464 of yacc.c  */
#line 1266 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 238:

/* Line 1464 of yacc.c  */
#line 1267 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 239:

/* Line 1464 of yacc.c  */
#line 1268 "cf-parse.y"
    { (yyval.v).type = (yyvsp[(1) - (1)].i) >> 16; (yyval.v).val.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 240:

/* Line 1464 of yacc.c  */
#line 1272 "cf-parse.y"
    {
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from.type = (yyval.e)->to.type = T_PAIR;
	(yyval.e)->from.val.i = make_pair((yyvsp[(2) - (5)].i), (yyvsp[(4) - (5)].i)); 
	(yyval.e)->to.val.i = make_pair((yyvsp[(2) - (5)].i), (yyvsp[(4) - (5)].i));
   ;}
    break;

  case 241:

/* Line 1464 of yacc.c  */
#line 1278 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from.type = (yyval.e)->to.type = T_PAIR;
	(yyval.e)->from.val.i = make_pair((yyvsp[(2) - (8)].i), (yyvsp[(4) - (8)].i)); 
	(yyval.e)->to.val.i = make_pair((yyvsp[(2) - (8)].i), (yyvsp[(7) - (8)].i));
   ;}
    break;

  case 242:

/* Line 1464 of yacc.c  */
#line 1284 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from.type = (yyval.e)->to.type = T_PAIR;
	(yyval.e)->from.val.i = make_pair((yyvsp[(2) - (12)].i), (yyvsp[(4) - (12)].i)); 
	(yyval.e)->to.val.i = make_pair((yyvsp[(9) - (12)].i), (yyvsp[(11) - (12)].i));
   ;}
    break;

  case 243:

/* Line 1464 of yacc.c  */
#line 1290 "cf-parse.y"
    { 	/* This is probably useless :-) */
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from.type = (yyval.e)->to.type = T_PAIR;
	(yyval.e)->from.val.i = 0;
	(yyval.e)->to.val.i = 0xffffffff;
   ;}
    break;

  case 244:

/* Line 1464 of yacc.c  */
#line 1296 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from.type = (yyval.e)->to.type = T_PAIR;
	(yyval.e)->from.val.i = make_pair((yyvsp[(2) - (5)].i), 0); 
	(yyval.e)->to.val.i = make_pair((yyvsp[(2) - (5)].i), 0xffff);
   ;}
    break;

  case 245:

/* Line 1464 of yacc.c  */
#line 1302 "cf-parse.y"
    { 
	(yyval.e) = f_generate_rev_wcard(0, 0xffff, (yyvsp[(4) - (5)].i));
   ;}
    break;

  case 246:

/* Line 1464 of yacc.c  */
#line 1309 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (1)].v); 
	(yyval.e)->to = (yyvsp[(1) - (1)].v);
   ;}
    break;

  case 247:

/* Line 1464 of yacc.c  */
#line 1314 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (4)].v); 
	(yyval.e)->to = (yyvsp[(4) - (4)].v); 
   ;}
    break;

  case 248:

/* Line 1464 of yacc.c  */
#line 1322 "cf-parse.y"
    { (yyval.e) = (yyvsp[(1) - (1)].e); ;}
    break;

  case 249:

/* Line 1464 of yacc.c  */
#line 1323 "cf-parse.y"
    { (yyval.e) = (yyvsp[(3) - (3)].e); (yyval.e)->left = (yyvsp[(1) - (3)].e); ;}
    break;

  case 250:

/* Line 1464 of yacc.c  */
#line 1327 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 251:

/* Line 1464 of yacc.c  */
#line 1334 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 252:

/* Line 1464 of yacc.c  */
#line 1335 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; ;}
    break;

  case 253:

/* Line 1464 of yacc.c  */
#line 1336 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; ;}
    break;

  case 254:

/* Line 1464 of yacc.c  */
#line 1337 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   ;}
    break;

  case 255:

/* Line 1464 of yacc.c  */
#line 1344 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); ;}
    break;

  case 256:

/* Line 1464 of yacc.c  */
#line 1345 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); ;}
    break;

  case 257:

/* Line 1464 of yacc.c  */
#line 1348 "cf-parse.y"
    { (yyval.e) = NULL; ;}
    break;

  case 258:

/* Line 1464 of yacc.c  */
#line 1349 "cf-parse.y"
    {
     (yyval.e) = (yyvsp[(2) - (4)].e);
     (yyval.e)->data = (yyvsp[(4) - (4)].x);
     (yyval.e)->left = (yyvsp[(1) - (4)].e);
   ;}
    break;

  case 259:

/* Line 1464 of yacc.c  */
#line 1354 "cf-parse.y"
    {
     (yyval.e) = f_new_tree(); 
     (yyval.e)->from.type = T_VOID; 
     (yyval.e)->to.type = T_VOID;
     (yyval.e)->data = (yyvsp[(3) - (3)].x);
     (yyval.e)->left = (yyvsp[(1) - (3)].e);
   ;}
    break;

  case 260:

/* Line 1464 of yacc.c  */
#line 1366 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 261:

/* Line 1464 of yacc.c  */
#line 1367 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 262:

/* Line 1464 of yacc.c  */
#line 1371 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 263:

/* Line 1464 of yacc.c  */
#line 1372 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 264:

/* Line 1464 of yacc.c  */
#line 1376 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 265:

/* Line 1464 of yacc.c  */
#line 1377 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 266:

/* Line 1464 of yacc.c  */
#line 1378 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; ;}
    break;

  case 267:

/* Line 1464 of yacc.c  */
#line 1379 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); ;}
    break;

  case 268:

/* Line 1464 of yacc.c  */
#line 1380 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 269:

/* Line 1464 of yacc.c  */
#line 1384 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 270:

/* Line 1464 of yacc.c  */
#line 1385 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 271:

/* Line 1464 of yacc.c  */
#line 1386 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 272:

/* Line 1464 of yacc.c  */
#line 1390 "cf-parse.y"
    {
        if (((yyvsp[(2) - (5)].x)->code == 'c') && ((yyvsp[(4) - (5)].x)->code == 'c'))
          { 
            if (((yyvsp[(2) - (5)].x)->aux != T_INT) || ((yyvsp[(4) - (5)].x)->aux != T_INT))
              cf_error( "Can't operate with value of non-integer type in pair constructor" );
            (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PAIR;  (yyval.x)->a2.i = make_pair((yyvsp[(2) - (5)].x)->a2.i, (yyvsp[(4) - (5)].x)->a2.i);
          }
	else
	  { (yyval.x) = f_new_inst(); (yyval.x)->code = P('m', 'p'); (yyval.x)->a1.p = (yyvsp[(2) - (5)].x); (yyval.x)->a2.p = (yyvsp[(4) - (5)].x); }
    ;}
    break;

  case 273:

/* Line 1464 of yacc.c  */
#line 1403 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 274:

/* Line 1464 of yacc.c  */
#line 1404 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  ;}
    break;

  case 275:

/* Line 1464 of yacc.c  */
#line 1405 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  ;}
    break;

  case 276:

/* Line 1464 of yacc.c  */
#line 1406 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); ;}
    break;

  case 277:

/* Line 1464 of yacc.c  */
#line 1407 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 278:

/* Line 1464 of yacc.c  */
#line 1408 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 279:

/* Line 1464 of yacc.c  */
#line 1409 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 280:

/* Line 1464 of yacc.c  */
#line 1410 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); ;}
    break;

  case 281:

/* Line 1464 of yacc.c  */
#line 1411 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); ;}
    break;

  case 282:

/* Line 1464 of yacc.c  */
#line 1412 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 283:

/* Line 1464 of yacc.c  */
#line 1413 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; ;}
    break;

  case 285:

/* Line 1464 of yacc.c  */
#line 1427 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 286:

/* Line 1464 of yacc.c  */
#line 1450 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_QUAD:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   ;}
    break;

  case 287:

/* Line 1464 of yacc.c  */
#line 1484 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; ;}
    break;

  case 288:

/* Line 1464 of yacc.c  */
#line 1486 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; ;}
    break;

  case 289:

/* Line 1464 of yacc.c  */
#line 1487 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ ;}
    break;

  case 290:

/* Line 1464 of yacc.c  */
#line 1488 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ ;}
    break;

  case 291:

/* Line 1464 of yacc.c  */
#line 1489 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); ;}
    break;

  case 292:

/* Line 1464 of yacc.c  */
#line 1490 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; ;}
    break;

  case 293:

/* Line 1464 of yacc.c  */
#line 1491 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); ;}
    break;

  case 294:

/* Line 1464 of yacc.c  */
#line 1492 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest); ;}
    break;

  case 295:

/* Line 1464 of yacc.c  */
#line 1496 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 296:

/* Line 1464 of yacc.c  */
#line 1497 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 297:

/* Line 1464 of yacc.c  */
#line 1498 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 298:

/* Line 1464 of yacc.c  */
#line 1499 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 299:

/* Line 1464 of yacc.c  */
#line 1500 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 300:

/* Line 1464 of yacc.c  */
#line 1501 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 301:

/* Line 1464 of yacc.c  */
#line 1502 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 302:

/* Line 1464 of yacc.c  */
#line 1503 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 303:

/* Line 1464 of yacc.c  */
#line 1504 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 304:

/* Line 1464 of yacc.c  */
#line 1505 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 305:

/* Line 1464 of yacc.c  */
#line 1506 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 306:

/* Line 1464 of yacc.c  */
#line 1507 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 307:

/* Line 1464 of yacc.c  */
#line 1508 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 308:

/* Line 1464 of yacc.c  */
#line 1509 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 309:

/* Line 1464 of yacc.c  */
#line 1510 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); ;}
    break;

  case 310:

/* Line 1464 of yacc.c  */
#line 1511 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); ;}
    break;

  case 311:

/* Line 1464 of yacc.c  */
#line 1513 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 312:

/* Line 1464 of yacc.c  */
#line 1514 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 313:

/* Line 1464 of yacc.c  */
#line 1515 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 314:

/* Line 1464 of yacc.c  */
#line 1517 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; ;}
    break;

  case 315:

/* Line 1464 of yacc.c  */
#line 1519 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; ;}
    break;

  case 316:

/* Line 1464 of yacc.c  */
#line 1521 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); ;}
    break;

  case 317:

/* Line 1464 of yacc.c  */
#line 1523 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; ;}
    break;

  case 318:

/* Line 1464 of yacc.c  */
#line 1524 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 319:

/* Line 1464 of yacc.c  */
#line 1525 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 320:

/* Line 1464 of yacc.c  */
#line 1526 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 321:

/* Line 1464 of yacc.c  */
#line 1527 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 322:

/* Line 1464 of yacc.c  */
#line 1537 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; ;}
    break;

  case 323:

/* Line 1464 of yacc.c  */
#line 1538 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; ;}
    break;

  case 324:

/* Line 1464 of yacc.c  */
#line 1539 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 325:

/* Line 1464 of yacc.c  */
#line 1540 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; ;}
    break;

  case 326:

/* Line 1464 of yacc.c  */
#line 1541 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; ;}
    break;

  case 327:

/* Line 1464 of yacc.c  */
#line 1546 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 328:

/* Line 1464 of yacc.c  */
#line 1569 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; ;}
    break;

  case 329:

/* Line 1464 of yacc.c  */
#line 1570 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; ;}
    break;

  case 330:

/* Line 1464 of yacc.c  */
#line 1571 "cf-parse.y"
    { (yyval.i) = F_REJECT; ;}
    break;

  case 331:

/* Line 1464 of yacc.c  */
#line 1572 "cf-parse.y"
    { (yyval.i) = F_ERROR; ;}
    break;

  case 332:

/* Line 1464 of yacc.c  */
#line 1573 "cf-parse.y"
    { (yyval.i) = F_NOP; ;}
    break;

  case 333:

/* Line 1464 of yacc.c  */
#line 1574 "cf-parse.y"
    { (yyval.i) = F_NONL; ;}
    break;

  case 334:

/* Line 1464 of yacc.c  */
#line 1578 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; ;}
    break;

  case 335:

/* Line 1464 of yacc.c  */
#line 1581 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 336:

/* Line 1464 of yacc.c  */
#line 1582 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 337:

/* Line 1464 of yacc.c  */
#line 1583 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 338:

/* Line 1464 of yacc.c  */
#line 1592 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   ;}
    break;

  case 339:

/* Line 1464 of yacc.c  */
#line 1599 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 340:

/* Line 1464 of yacc.c  */
#line 1608 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 341:

/* Line 1464 of yacc.c  */
#line 1609 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 342:

/* Line 1464 of yacc.c  */
#line 1613 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   ;}
    break;

  case 343:

/* Line 1464 of yacc.c  */
#line 1619 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   ;}
    break;

  case 344:

/* Line 1464 of yacc.c  */
#line 1629 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 345:

/* Line 1464 of yacc.c  */
#line 1638 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   ;}
    break;

  case 346:

/* Line 1464 of yacc.c  */
#line 1644 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 347:

/* Line 1464 of yacc.c  */
#line 1649 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 348:

/* Line 1464 of yacc.c  */
#line 1656 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 349:

/* Line 1464 of yacc.c  */
#line 1661 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   ;}
    break;

  case 350:

/* Line 1464 of yacc.c  */
#line 1667 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); ;}
    break;

  case 351:

/* Line 1464 of yacc.c  */
#line 1668 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); ;}
    break;

  case 352:

/* Line 1464 of yacc.c  */
#line 1669 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   ;}
    break;

  case 353:

/* Line 1464 of yacc.c  */
#line 1678 "cf-parse.y"
    { struct f_inst *i = f_new_inst(); i->code = 'E'; i->aux = T_CLIST; (yyval.x) = (yyvsp[(2) - (5)].x); (yyval.x)->code = P('e','S'); (yyval.x)->a1.p = i; ;}
    break;

  case 354:

/* Line 1464 of yacc.c  */
#line 1679 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 355:

/* Line 1464 of yacc.c  */
#line 1680 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 356:

/* Line 1464 of yacc.c  */
#line 1681 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 357:

/* Line 1464 of yacc.c  */
#line 1687 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config));
     this_proto->preference = DEF_PREF_BGP;
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 ;}
    break;

  case 360:

/* Line 1464 of yacc.c  */
#line 1711 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); ;}
    break;

  case 361:

/* Line 1464 of yacc.c  */
#line 1712 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); ;}
    break;

  case 362:

/* Line 1464 of yacc.c  */
#line 1713 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip)) cf_error("Only one neighbor per BGP instance is allowed");

     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     BGP_CFG->remote_as = (yyvsp[(5) - (6)].i);
   ;}
    break;

  case 363:

/* Line 1464 of yacc.c  */
#line 1719 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); ;}
    break;

  case 364:

/* Line 1464 of yacc.c  */
#line 1720 "cf-parse.y"
    { BGP_CFG->rr_client = 1; ;}
    break;

  case 365:

/* Line 1464 of yacc.c  */
#line 1721 "cf-parse.y"
    { BGP_CFG->rs_client = 1; ;}
    break;

  case 366:

/* Line 1464 of yacc.c  */
#line 1722 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 367:

/* Line 1464 of yacc.c  */
#line 1723 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 368:

/* Line 1464 of yacc.c  */
#line 1724 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 369:

/* Line 1464 of yacc.c  */
#line 1725 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 370:

/* Line 1464 of yacc.c  */
#line 1726 "cf-parse.y"
    { BGP_CFG->multihop = 64; ;}
    break;

  case 371:

/* Line 1464 of yacc.c  */
#line 1727 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); ;}
    break;

  case 372:

/* Line 1464 of yacc.c  */
#line 1728 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; ;}
    break;

  case 373:

/* Line 1464 of yacc.c  */
#line 1729 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; ;}
    break;

  case 374:

/* Line 1464 of yacc.c  */
#line 1730 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; ;}
    break;

  case 375:

/* Line 1464 of yacc.c  */
#line 1731 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; ;}
    break;

  case 376:

/* Line 1464 of yacc.c  */
#line 1732 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; ;}
    break;

  case 377:

/* Line 1464 of yacc.c  */
#line 1733 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; ;}
    break;

  case 378:

/* Line 1464 of yacc.c  */
#line 1734 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); ;}
    break;

  case 379:

/* Line 1464 of yacc.c  */
#line 1735 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); ;}
    break;

  case 380:

/* Line 1464 of yacc.c  */
#line 1736 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); ;}
    break;

  case 381:

/* Line 1464 of yacc.c  */
#line 1737 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); ;}
    break;

  case 382:

/* Line 1464 of yacc.c  */
#line 1738 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 383:

/* Line 1464 of yacc.c  */
#line 1739 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); ;}
    break;

  case 384:

/* Line 1464 of yacc.c  */
#line 1740 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); ;}
    break;

  case 385:

/* Line 1464 of yacc.c  */
#line 1741 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 386:

/* Line 1464 of yacc.c  */
#line 1742 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 387:

/* Line 1464 of yacc.c  */
#line 1743 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); ;}
    break;

  case 388:

/* Line 1464 of yacc.c  */
#line 1744 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); ;}
    break;

  case 389:

/* Line 1464 of yacc.c  */
#line 1745 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); ;}
    break;

  case 390:

/* Line 1464 of yacc.c  */
#line 1746 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 391:

/* Line 1464 of yacc.c  */
#line 1747 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); ;}
    break;

  case 392:

/* Line 1464 of yacc.c  */
#line 1748 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 393:

/* Line 1464 of yacc.c  */
#line 1749 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); ;}
    break;

  case 394:

/* Line 1464 of yacc.c  */
#line 1750 "cf-parse.y"
    { BGP_CFG->route_limit = (yyvsp[(4) - (5)].i); ;}
    break;

  case 395:

/* Line 1464 of yacc.c  */
#line 1751 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); ;}
    break;

  case 396:

/* Line 1464 of yacc.c  */
#line 1752 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); ;}
    break;

  case 397:

/* Line 1464 of yacc.c  */
#line 1753 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); ;}
    break;

  case 398:

/* Line 1464 of yacc.c  */
#line 1763 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config));
     this_proto->preference = DEF_PREF_OSPF;
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  ;}
    break;

  case 402:

/* Line 1464 of yacc.c  */
#line 1780 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); ;}
    break;

  case 403:

/* Line 1464 of yacc.c  */
#line 1781 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; ;}
    break;

  case 404:

/* Line 1464 of yacc.c  */
#line 1782 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); ;}
    break;

  case 405:

/* Line 1464 of yacc.c  */
#line 1783 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); ;}
    break;

  case 407:

/* Line 1464 of yacc.c  */
#line 1787 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->stub = 0;
  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->stubnet_list);
 ;}
    break;

  case 408:

/* Line 1464 of yacc.c  */
#line 1798 "cf-parse.y"
    { ospf_area_finish(); ;}
    break;

  case 411:

/* Line 1464 of yacc.c  */
#line 1807 "cf-parse.y"
    { this_area->stub = (yyvsp[(3) - (3)].i) ; if((yyvsp[(3) - (3)].i)<=0) cf_error("Stub cost must be greater than zero"); ;}
    break;

  case 412:

/* Line 1464 of yacc.c  */
#line 1808 "cf-parse.y"
    {if((yyvsp[(2) - (2)].i)) { if(!this_area->stub) this_area->stub=DEFAULT_STUB_COST;}else{ this_area->stub=0;};}
    break;

  case 419:

/* Line 1464 of yacc.c  */
#line 1821 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   ;}
    break;

  case 422:

/* Line 1464 of yacc.c  */
#line 1835 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); ;}
    break;

  case 423:

/* Line 1464 of yacc.c  */
#line 1836 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 424:

/* Line 1464 of yacc.c  */
#line 1837 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); ;}
    break;

  case 425:

/* Line 1464 of yacc.c  */
#line 1841 "cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 430:

/* Line 1464 of yacc.c  */
#line 1851 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 431:

/* Line 1464 of yacc.c  */
#line 1852 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 432:

/* Line 1464 of yacc.c  */
#line 1853 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 433:

/* Line 1464 of yacc.c  */
#line 1854 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 434:

/* Line 1464 of yacc.c  */
#line 1855 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 435:

/* Line 1464 of yacc.c  */
#line 1856 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 436:

/* Line 1464 of yacc.c  */
#line 1857 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 437:

/* Line 1464 of yacc.c  */
#line 1858 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 438:

/* Line 1464 of yacc.c  */
#line 1859 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 440:

/* Line 1464 of yacc.c  */
#line 1864 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 441:

/* Line 1464 of yacc.c  */
#line 1885 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); ;}
    break;

  case 442:

/* Line 1464 of yacc.c  */
#line 1886 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 443:

/* Line 1464 of yacc.c  */
#line 1887 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); ;}
    break;

  case 444:

/* Line 1464 of yacc.c  */
#line 1888 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 445:

/* Line 1464 of yacc.c  */
#line 1889 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 446:

/* Line 1464 of yacc.c  */
#line 1890 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 447:

/* Line 1464 of yacc.c  */
#line 1891 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 448:

/* Line 1464 of yacc.c  */
#line 1892 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 449:

/* Line 1464 of yacc.c  */
#line 1893 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 450:

/* Line 1464 of yacc.c  */
#line 1894 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 451:

/* Line 1464 of yacc.c  */
#line 1895 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 452:

/* Line 1464 of yacc.c  */
#line 1896 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 453:

/* Line 1464 of yacc.c  */
#line 1897 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 454:

/* Line 1464 of yacc.c  */
#line 1898 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; ;}
    break;

  case 455:

/* Line 1464 of yacc.c  */
#line 1899 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; ;}
    break;

  case 456:

/* Line 1464 of yacc.c  */
#line 1900 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 457:

/* Line 1464 of yacc.c  */
#line 1901 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); ;}
    break;

  case 458:

/* Line 1464 of yacc.c  */
#line 1902 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; ;}
    break;

  case 459:

/* Line 1464 of yacc.c  */
#line 1903 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 460:

/* Line 1464 of yacc.c  */
#line 1904 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); ;}
    break;

  case 461:

/* Line 1464 of yacc.c  */
#line 1905 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); ;}
    break;

  case 463:

/* Line 1464 of yacc.c  */
#line 1907 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 464:

/* Line 1464 of yacc.c  */
#line 1908 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 465:

/* Line 1464 of yacc.c  */
#line 1909 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 466:

/* Line 1464 of yacc.c  */
#line 1910 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; ;}
    break;

  case 467:

/* Line 1464 of yacc.c  */
#line 1911 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; ;}
    break;

  case 468:

/* Line 1464 of yacc.c  */
#line 1912 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); ;}
    break;

  case 474:

/* Line 1464 of yacc.c  */
#line 1926 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (2)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (2)].px).len;
 ;}
    break;

  case 475:

/* Line 1464 of yacc.c  */
#line 1935 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (3)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (3)].px).len;
   this_pref->hidden = 1;
 ;}
    break;

  case 480:

/* Line 1464 of yacc.c  */
#line 1954 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 ;}
    break;

  case 481:

/* Line 1464 of yacc.c  */
#line 1963 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 ;}
    break;

  case 482:

/* Line 1464 of yacc.c  */
#line 1973 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 487:

/* Line 1464 of yacc.c  */
#line 2004 "cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 489:

/* Line 1464 of yacc.c  */
#line 2009 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 490:

/* Line 1464 of yacc.c  */
#line 2014 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); ;}
    break;

  case 491:

/* Line 1464 of yacc.c  */
#line 2017 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 492:

/* Line 1464 of yacc.c  */
#line 2020 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 493:

/* Line 1464 of yacc.c  */
#line 2025 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); ;}
    break;

  case 494:

/* Line 1464 of yacc.c  */
#line 2028 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); ;}
    break;

  case 495:

/* Line 1464 of yacc.c  */
#line 2033 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); ;}
    break;

  case 496:

/* Line 1464 of yacc.c  */
#line 2036 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); ;}
    break;

  case 497:

/* Line 1464 of yacc.c  */
#line 2039 "cf-parse.y"
    { ospf_sh_lsadb(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf)); ;}
    break;

  case 498:

/* Line 1464 of yacc.c  */
#line 2044 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config));
     this_proto->preference = DEF_PREF_PIPE;
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  ;}
    break;

  case 501:

/* Line 1464 of yacc.c  */
#line 2054 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   ;}
    break;

  case 502:

/* Line 1464 of yacc.c  */
#line 2059 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; ;}
    break;

  case 503:

/* Line 1464 of yacc.c  */
#line 2060 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; ;}
    break;

  case 504:

/* Line 1464 of yacc.c  */
#line 2067 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, sizeof(struct radv_config));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
;}
    break;

  case 506:

/* Line 1464 of yacc.c  */
#line 2075 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); ;}
    break;

  case 511:

/* Line 1464 of yacc.c  */
#line 2089 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
;}
    break;

  case 512:

/* Line 1464 of yacc.c  */
#line 2103 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); ;}
    break;

  case 513:

/* Line 1464 of yacc.c  */
#line 2104 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); ;}
    break;

  case 514:

/* Line 1464 of yacc.c  */
#line 2105 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); ;}
    break;

  case 515:

/* Line 1464 of yacc.c  */
#line 2106 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); ;}
    break;

  case 516:

/* Line 1464 of yacc.c  */
#line 2107 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); ;}
    break;

  case 517:

/* Line 1464 of yacc.c  */
#line 2108 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); ;}
    break;

  case 518:

/* Line 1464 of yacc.c  */
#line 2109 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); ;}
    break;

  case 519:

/* Line 1464 of yacc.c  */
#line 2110 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); ;}
    break;

  case 520:

/* Line 1464 of yacc.c  */
#line 2111 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); ;}
    break;

  case 521:

/* Line 1464 of yacc.c  */
#line 2112 "cf-parse.y"
    { RADV_IFACE->default_lifetime = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000"); ;}
    break;

  case 522:

/* Line 1464 of yacc.c  */
#line 2113 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); ;}
    break;

  case 523:

/* Line 1464 of yacc.c  */
#line 2117 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = _MAX(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
;}
    break;

  case 529:

/* Line 1464 of yacc.c  */
#line 2150 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
;}
    break;

  case 530:

/* Line 1464 of yacc.c  */
#line 2162 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); ;}
    break;

  case 531:

/* Line 1464 of yacc.c  */
#line 2163 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); ;}
    break;

  case 532:

/* Line 1464 of yacc.c  */
#line 2164 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); ;}
    break;

  case 533:

/* Line 1464 of yacc.c  */
#line 2165 "cf-parse.y"
    { RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Valid lifetime must be 0 or positive"); ;}
    break;

  case 534:

/* Line 1464 of yacc.c  */
#line 2166 "cf-parse.y"
    { RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Preferred lifetime must be 0 or positive"); ;}
    break;

  case 535:

/* Line 1464 of yacc.c  */
#line 2170 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");
;}
    break;

  case 541:

/* Line 1464 of yacc.c  */
#line 2192 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config));
     rip_init_config(RIP_CFG);
   ;}
    break;

  case 544:

/* Line 1464 of yacc.c  */
#line 2201 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); ;}
    break;

  case 545:

/* Line 1464 of yacc.c  */
#line 2202 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); ;}
    break;

  case 546:

/* Line 1464 of yacc.c  */
#line 2203 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); ;}
    break;

  case 547:

/* Line 1464 of yacc.c  */
#line 2204 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 548:

/* Line 1464 of yacc.c  */
#line 2205 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 549:

/* Line 1464 of yacc.c  */
#line 2206 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); ;}
    break;

  case 551:

/* Line 1464 of yacc.c  */
#line 2208 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; ;}
    break;

  case 552:

/* Line 1464 of yacc.c  */
#line 2209 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; ;}
    break;

  case 553:

/* Line 1464 of yacc.c  */
#line 2210 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; ;}
    break;

  case 555:

/* Line 1464 of yacc.c  */
#line 2215 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; ;}
    break;

  case 556:

/* Line 1464 of yacc.c  */
#line 2216 "cf-parse.y"
    { (yyval.i)=AT_MD5; ;}
    break;

  case 557:

/* Line 1464 of yacc.c  */
#line 2217 "cf-parse.y"
    { (yyval.i)=AT_NONE; ;}
    break;

  case 558:

/* Line 1464 of yacc.c  */
#line 2222 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; ;}
    break;

  case 559:

/* Line 1464 of yacc.c  */
#line 2223 "cf-parse.y"
    { (yyval.i)=0; ;}
    break;

  case 560:

/* Line 1464 of yacc.c  */
#line 2224 "cf-parse.y"
    { (yyval.i)=IM_QUIET; ;}
    break;

  case 561:

/* Line 1464 of yacc.c  */
#line 2225 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; ;}
    break;

  case 562:

/* Line 1464 of yacc.c  */
#line 2226 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; ;}
    break;

  case 564:

/* Line 1464 of yacc.c  */
#line 2230 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); ;}
    break;

  case 565:

/* Line 1464 of yacc.c  */
#line 2231 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); ;}
    break;

  case 570:

/* Line 1464 of yacc.c  */
#line 2245 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   ;}
    break;

  case 572:

/* Line 1464 of yacc.c  */
#line 2261 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config));
     static_init_config((struct static_config *) this_proto);
  ;}
    break;

  case 575:

/* Line 1464 of yacc.c  */
#line 2270 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); ;}
    break;

  case 577:

/* Line 1464 of yacc.c  */
#line 2274 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  ;}
    break;

  case 578:

/* Line 1464 of yacc.c  */
#line 2283 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (2)].a);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   ;}
    break;

  case 579:

/* Line 1464 of yacc.c  */
#line 2290 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   ;}
    break;

  case 580:

/* Line 1464 of yacc.c  */
#line 2297 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; ;}
    break;

  case 581:

/* Line 1464 of yacc.c  */
#line 2298 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; ;}
    break;

  case 582:

/* Line 1464 of yacc.c  */
#line 2302 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (3)].a);
   ;}
    break;

  case 583:

/* Line 1464 of yacc.c  */
#line 2306 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   ;}
    break;

  case 584:

/* Line 1464 of yacc.c  */
#line 2312 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   ;}
    break;

  case 585:

/* Line 1464 of yacc.c  */
#line 2315 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 586:

/* Line 1464 of yacc.c  */
#line 2316 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 587:

/* Line 1464 of yacc.c  */
#line 2317 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; ;}
    break;

  case 588:

/* Line 1464 of yacc.c  */
#line 2321 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); ;}
    break;

  case 642:

/* Line 1464 of yacc.c  */
#line 2329 "cf-parse.y"
    { bgp_check(BGP_CFG); ;}
    break;

  case 643:

/* Line 1464 of yacc.c  */
#line 2329 "cf-parse.y"
    { ospf_proto_finish(); ;}
    break;

  case 646:

/* Line 1464 of yacc.c  */
#line 2329 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); ;}
    break;

  case 655:

/* Line 1464 of yacc.c  */
#line 2332 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); ;}
    break;

  case 656:

/* Line 1464 of yacc.c  */
#line 2332 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); ;}
    break;

  case 657:

/* Line 1464 of yacc.c  */
#line 2333 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); ;}
    break;

  case 658:

/* Line 1464 of yacc.c  */
#line 2333 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 659:

/* Line 1464 of yacc.c  */
#line 2334 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); ;}
    break;

  case 660:

/* Line 1464 of yacc.c  */
#line 2335 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); ;}
    break;

  case 661:

/* Line 1464 of yacc.c  */
#line 2336 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); ;}
    break;

  case 662:

/* Line 1464 of yacc.c  */
#line 2337 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); ;}
    break;

  case 663:

/* Line 1464 of yacc.c  */
#line 2338 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); ;}
    break;

  case 664:

/* Line 1464 of yacc.c  */
#line 2339 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); ;}
    break;

  case 665:

/* Line 1464 of yacc.c  */
#line 2340 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); ;}
    break;

  case 666:

/* Line 1464 of yacc.c  */
#line 2341 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); ;}
    break;

  case 667:

/* Line 1464 of yacc.c  */
#line 2342 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); ;}
    break;

  case 668:

/* Line 1464 of yacc.c  */
#line 2343 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); ;}
    break;

  case 669:

/* Line 1464 of yacc.c  */
#line 2343 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); ;}
    break;

  case 670:

/* Line 1464 of yacc.c  */
#line 2343 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); ;}
    break;

  case 671:

/* Line 1464 of yacc.c  */
#line 2343 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); ;}
    break;

  case 672:

/* Line 1464 of yacc.c  */
#line 2343 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); ;}
    break;

  case 673:

/* Line 1464 of yacc.c  */
#line 2343 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); ;}
    break;

  case 674:

/* Line 1464 of yacc.c  */
#line 2343 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); ;}
    break;



/* Line 1464 of yacc.c  */
#line 7582 "cf-parse.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 2345 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


